#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
const int cnt = 7;
int n, q;
vvi a;
vvi sep[cnt];
vi pos[cnt];
vi lens, og;
const int pow10[cnt] = {1, 10, 100, 1000, 10000, 100000, 1000000};

void read()
{
    cin >>n >>q;
    a.resize(n);
    og.resize(n);
    lens.resize(n, 0);
    for(int i = 0, num; i < n; i++)
    {
        cin >>og[i];
        a[i].reserve(cnt);
        num = og[i];
        while(num)
        {
            a[i].emplace_back(num % 10);
            num /= 10;
            lens[i]++;
        }
        lens[i]--;
    }
    for(int i = 0; i < n; i++)
    {
        sep[lens[i]].emplace_back(a[i].size());
        for(int j = 0; j < a[i].size(); j++)
           sep[lens[i]].back()[j] = a[i][j];
        pos[lens[i]].emplace_back(i);
    }
}

#define all(x) x.begin(), x.end()
int findIndex(int i, int id1)
{ return lower_bound(all(pos[id1]), i) - pos[id1].begin(); }

struct LDigitSegTree
{
public:
    int id1, len, n;
    vvi seg;
    vi lz;
    vi cp;
    bool empty = 0;

    #define segTree 1, 0, this->n
    LDigitSegTree() : id1(0), len(0){}
    LDigitSegTree(int _n, int _id1) : n(_n), id1(_id1), len(_id1 + 1)
    {
        if(!this->n)
        {
            this->empty = 1;
            return;
        }
        this->seg.assign(this->n << 1, vi(this->len, 0));
        this->lz.assign(this->seg.size(), 0);
        this->cp.resize(len);
        this->build(segTree);
    }

    void build(int v, int l, int r)
    {
        if(r - l == 1)
        {
            for(int id2 = 0; id2 < this->len; id2++)
                this->seg[v][id2] = sep[this->id1][l][id2];
            return;
        }
        int mid = l + (r - l >> 1),
            le = v + 1,
            ri = v + (mid - l << 1);
        this->build(le, l, mid);
        this->build(ri, mid, r);
        for(int id2 = 0; id2 < this->len; id2++)
            this->seg[v][id2] = this->seg[le][id2] + this->seg[ri][id2];
    }

    void rotate(vector<int>& a, int iter)
    {
        for(int id2 = 0; id2 < this->len; id2++)
            this->cp[id2] = a[id2];
        for(int id2 = 0; id2 < this->len; id2++)
            a[id2] = this->cp[(id2 + iter) % this->len];
    }

    void push(int v, int le, int ri)
    {
        this->rotate(this->seg[le], this->lz[v]);
        this->rotate(this->seg[ri], this->lz[v]);
        this->lz[le] = (this->lz[le] + this->lz[v]) % this->id1;
        this->lz[ri] = (this->lz[ri] + this->lz[v]) % this->id1;
        this->lz[v] = 0;
    }

    void comb(int v, int le, int ri)
    {
        for(int id2 = 0; id2 < this->len; id2++)
            this->seg[v][id2] = this->seg[le][id2] + this->seg[ri][id2];
    }

    int qL, qR;
    void update(int v, int l, int r)
    {
        if(this->qR <= l || r <= this->qL) return;
        if(this->qL <= l && r <= this->qR)
        {
            this->rotate(this->seg[v], 1);
            this->lz[v]++;
            this->lz[v] %= this->len;
            return;
        }
        int mid = l + (r - l >> 1),
            le = v + 1,
            ri = v + (mid - l << 1);
        if(this->lz[v])
            this->push(v, le, ri);
        this->update(le, l, mid);
        this->update(ri, mid, r);
        this->comb(v, le, ri);
    }
    void update(int l, int r)
    {
        if(l == r || this->empty) return;
        this->qL = l, this->qR = r;
        this->update(segTree);
    }

    ll query(int v, int l, int r)
    {
        if(this->qR <= l || r <= this->qL) return 0LL;
        if(this->qL <= l && r <= this->qR)
        {
            ll sum = 0;
            for(int id2 = 0; id2 < this->len; id2++)
                sum += this->seg[v][id2] * pow10[id2];
            return sum;
        }
        int mid = l + (r - l >> 1),
            le = v + 1,
            ri = v + (mid - l << 1);
        if(this->lz[v])
            this->push(v, le, ri);
        ll d = this->query(le, l, mid) +
               this->query(ri, mid, r);
        this->comb(v, le, ri);
        return d;
    }
    ll query(int l, int r)
    {
        this->qL = l, this->qR = r;
        return l == r || this->empty ? 0 : this->query(segTree);
    }
};
LDigitSegTree digSegTrees[cnt];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    read();
    for(int id1 = 0; id1 < cnt; id1++)
        digSegTrees[id1] = LDigitSegTree(sep[id1].size(), id1);
    int qL, qR;
    char c;
    while(q--)
    {
        cin >>c >>qL >>qR;
        qL--;
        if(c == '1')
        {
            for(int id1 = 0; id1 < cnt; id1++)
                //(cout <<id1 <<": " <<qL <<qR <<" -> " <<findIndex(qL, id1) <<" " <<findIndex(qR, id1) <<endl),
                digSegTrees[id1].update(findIndex(qL, id1), findIndex(qR, id1));
        }
        else
        {
            ll sum = 0;
            for(int id1 = 0; id1 < cnt; id1++)
                //(cout <<id1 <<": " <<qL <<qR <<" -> " <<findIndex(qL, id1) <<" " <<findIndex(qR, id1) <<endl),
                sum += digSegTrees[id1].query(findIndex(qL, id1), findIndex(qR, id1));//,
                //(cout <<"After " <<id1 <<": " <<sum <<endl);
            cout <<sum <<"\n";// <<endl;
        }
    }
}
/*
3 3
123 456 7787
2 1 2
1 1 2
2 2 3
*/
