#include <iostream>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <set>
#include <stdio.h>
#include <math.h>

using namespace std;

int n,Q;
int nums[1000010];
int digits[1000010];
struct Node
{
    Node *l,*r;
    Node *par;
    int from;
    int to;
    int val;
    int lp;	
    Node(int f,int t,Node* P)
    {
        from=f;
        to=t;
        l=NULL;
        r=NULL;
        par=P;
    }
}*Root,*Leafs[1000010];

void build(Node* node,int from,int to)
{
    if(from==to)
    {
        node->l=NULL;
        node->r=NULL;
        node->val=nums[from];
        Leafs[from]=node;
        return;
    }
    node->l=new Node(from,(from+to)/2,node);
    build(node->l,from,(from+to)/2);
    node->r=new Node((from+to)/2+1,to,node);
    build(node->r,(from+to)/2+1,to);
    node->val=node->l->val+node->r->val;
}

void Update(Node* node,int from,int to)
{
    if(node==NULL)return;
    if(node->to<from||node->from>to)return;
    if(node->from==node->to)
        node->val=(node->val%10)*digits[node->from]+node->val/10;
    else
    {
        Update(node->l,from,to);
        Update(node->r,from,to);
        node->val=node->l->val+node->r->val;
    }
}

long long getSum(Node* node,int from,int to)
{
    if(node==NULL)return 0;
    if(node->to<from||node->from>to)return 0;
    if(node->from>=from&&node->to<=to)return node->val;
    else return getSum(node->l,from,to)+getSum(node->r,from,to);
}

void Update1(Node* leaf)
{
    if(leaf==NULL)return;
    if(leaf->from!=leaf->to)
        leaf->val=leaf->l->val+leaf->r->val;
    else
        leaf->val=(leaf->val%10)*digits[leaf->from]+leaf->val/10;
//    cout<<leaf->from<<" "<<leaf->to<<"  "<<leaf->val<<endl;
    Update1(leaf->par);
}

void Print(Node* node,int depth)
{
    if(node==NULL)return;
    Print(node->l,depth+1);
    for(int i=0;i<depth;i++)cout<<"             ";
    cout<<node->val;
    if(node->par!=NULL)cout<<"- "<<node->par->val;
    cout<<endl;
    Print(node->r,depth+1);
}

int main()
{
    int a,b,c;
    scanf("%d%d",&n,&Q);
    for(int i=0;i<n;i++)
        scanf("%d",&nums[i]);
    Root=new Node(0,n-1,NULL);
    build(Root,0,n-1);
    
    for(int i=0;i<n;i++)
        digits[i]=pow(10,floor(log10(nums[i]) ) );
//	for(int i=0;i<n;i++)
//		cout<<digits[i]<<"  ";
//		cout<<endl;
//	Update(Root,1,6);
//	Print(Root,0);
    for(int i=0;i<Q;i++)
    {
        scanf("%d%d%d",&a,&b,&c);
        if(a==1)
        {
            if(b==c)Update1(Leafs[b-1]);
            else Update(Root,b-1,c-1);
        }
        else cout<<getSum(Root,b-1,c-1)<<endl;
    }
//    Print(Root,0);
    
}
/*
8 3
123 2543 15678 28 53 348 4956 38987
2 1 2
1 1 1
2 1 2

*/
