#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef long long ll;

const int MAXN = 1000003;
int n, q;
int arr[MAXN];
int rot[MAXN][7];
int dig[MAXN];
int step[MAXN];
ll tree[MAXN << 2];
int pending[MAXN << 2];

void merge_v(int v)
{
    tree[v] = tree[v << 1] + tree[(v << 1) + 1];
}

void update_leaf(int v, int idx)
{
    step[idx] += pending[v];
    step[idx] %= dig[idx];
    tree[v] = rot[idx][step[idx]];
    pending[v] = 0;
}

void push(int v, int l, int r)
{
    if (!pending[v])
        return;

    if (l != r)
    {
        pending[v << 1] += pending[v];
        pending[(v << 1) + 1] += pending[v];
    }
    else
    {
        update_leaf(v, l);
    }

    pending[v] = 0;
    //merge_v(v);
}

void spread(int v, int l, int r)
{
    if (!pending[v])
        return;

    if (l != r)
    {
        pending[v << 1] += pending[v];
        pending[(v << 1) + 1] += pending[v];
        int mid = (l + r) >> 1;
        spread(v << 1, l, mid);
        spread((v << 1) + 1, mid + 1, r);
    }
    else
    {
        update_leaf(v, l);
    }

    pending[v] = 0;
    //merge_v(v);
}

void update(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return;

    push(v, l, r);
//    if (l == r)
//    {
//        ++step[l];
//        step[l] %= dig[l];
//        tree[v] = rot[l][step[l]];
//        return;
//    }
    if (l >= x && r <= y)
    {
        ++pending[v];
        return;
    }

    int mid = (l + r) >> 1;
    update(v << 1, l, mid, x, y);
    update((v << 1) + 1, mid + 1, r, x, y);
    merge_v(v);
}

ll query(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return 0;

    push(v, l, r);
//    if (l >= x && r <= y)
    if (l == r)
    {
        //spread(v, l, r);
        return tree[v];
    }

    int mid = (l + r) >> 1;
    ll query_left = query(v << 1, l, mid, x, y);
    ll query_right = query((v << 1) + 1, mid + 1, r, x, y);
    return query_left + query_right;
}

pair<int, int> get_max(int x)
{
    int ret = 1;
    int cnt = 1;
    while (ret * 10 <= x)
    {
        ret *= 10;
        ++cnt;
    }

    return {ret, cnt};
}

void get_rot(int idx)
{
    //cout << endl;
    //cout << "get rot: " << endl;
    int tmp = arr[idx];
    pair<int, int> res = get_max(tmp);
    int lim = res.first;
    int cnt = res.second;
    dig[idx] = cnt;

    //cout << tmp << " " << dig[idx] << " " << lim << endl;

    rot[idx][0] = tmp;
    for (int i = 1; i < cnt; ++i)
    {
        int next = (tmp + (lim * 10 - 1) * (tmp % 10)) / 10;
        rot[idx][i] = next;
        tmp = next;
    }
}

void print_tree(int v, int l, int r)
{
    cout << v << ": " << l << " - " << r << endl;
    cout << tree[v] << ", " << pending[v] << endl;

    if (l == r)
        return;

    int mid = (l + r) >> 1;
    print_tree(v << 1, l, mid);
    print_tree((v << 1) + 1, mid + 1, r);
}

void input()
{
    cin >> n >> q;
    for (int i = 1; i <= n; ++i)
    {
        cin >> arr[i];
        get_rot(i);
    }
}

void build(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return;

    if (l == r)
    {
        tree[v] = arr[l];
        return;
    }

    int mid = (l + r) >> 1;
    build(v << 1, l, mid, x, y);
    build((v << 1) + 1, mid + 1, r, x, y);
    merge_v(v);
}

void solve()
{
    build(1, 1, n, 1, n);

//    for (int i = 1; i <= n; ++i)
//    {
//        for (int j = 0; j < dig[i]; ++j)
//            cout << rot[i][j] << " ";
//        cout << endl;
//    }

    for (int test = 0; test < q; ++test)
    {
        int type, l, r;
        cin >> type >> l >> r;

//        cout << endl;
//        print_tree(1, 1, n);

        if (type == 1)
        {
            update(1, 1, n, l, r);
        }
        else if (type == 2)
        {
            ll res = query(1, 1, n, l, r);
            cout << res << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
