#include<bits/stdc++.h>
#define ll long long
#define fr first
#define sc second
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 1e6 + 6;

int get_len(int x){
    int ret = 0;
    while(x){
        x /= 10;
        ++ ret;
    }
    return ret;
}

struct Node{
    int lazy = 0;
    int A[7][7] = {0};
    Node() {}

    Node(int x){
        int len = get_len(x);
        int curr = 1;
        while(x){
            A[len][curr] += x % 10;
            x /= 10;
            ++ curr;
        }
    }
    friend Node merge(Node a, Node b){
        Node c = Node();
        for(int i = 0; i < 7; i ++) for(int j = 0; j < 7; j ++){
            c.A[i][j] = a.A[i][j] + b.A[i][j];
        }
        return c;
    }
    ll get(){
        ll sum = 0;
        for(int i = 1; i <= 6; i ++){
            for(int j = 1, p = 1; j <= 6; j ++, p *= 10){
                sum += A[i][j] * p;
            }
        }
        return sum;
    }

};

int n, q;
Node segmtree[4 * MAXN];

void push(int node, int l, int r){
    if(segmtree[node].lazy){
        for(int len = 2; len <= 6; len ++){
            int curr_lazy = segmtree[node].lazy % len;
            for(int iter = 0; iter < curr_lazy; iter ++){
                for(int i = 2; i <= len; i ++){
                    swap(segmtree[node].A[len][i], segmtree[node].A[len][i - 1]);
                }
            }
        }
        if(l != r){
            segmtree[2 * node + 0].lazy += segmtree[node].lazy;
            segmtree[2 * node + 1].lazy += segmtree[node].lazy;
        }
        segmtree[node].lazy = 0;
    }
}

void put(int node, int l, int r, int x, int v){
    if(l == r){
        segmtree[node] = Node(v);
    }
    else{
        int m = (l + r) / 2;
        if(l <= x && x <= m) put(2 * node + 0, l + 0, m, x, v);
        else                 put(2 * node + 1, m + 1, r, x, v);
        segmtree[node] = merge(segmtree[2 * node + 0], segmtree[2 * node + 1]);
    }
}

void upd(int node, int l, int r, int ql, int qr){
    if(qr < l || r < ql){
        return;
    }
    else if(ql <= l && r <= qr){
        segmtree[node].lazy += 1;
        push(node, l, r);
    }
    else{
        int m = (l + r) / 2;

        upd(2 * node + 0, l + 0, m, ql, qr);
        upd(2 * node + 1, m + 1, r, ql, qr);

        push(node, l, r);
        push(2 * node + 0, l + 0, m);
        push(2 * node + 1, m + 1, r);

        segmtree[node] = merge(segmtree[2 * node + 0], segmtree[2 * node + 1]);
    }
}

Node qry(int node, int l, int r, int ql, int qr){
    if(qr < l || r < ql){
        return Node();
    }
    else if(ql <= l && r <= qr){
        push(node, l, r);
        return segmtree[node];
    }
    else{
        int m = (l + r) / 2;
        push(node, l, r);
        return merge(qry(2 * node + 0, l, m, ql, qr), qry(2 * node + 1, m + 1, r, ql, qr));
    }
}

ll __test[5005], pw[10] = {1, 10, 100, 1000, 10000, 100000, 1000000};

void __upd(int l, int r){
    for(int i = l; i <= r; i ++){
        int last = __test[i] % 10;
        __test[i] /= 10;
        __test[i] += last * pw[get_len(__test[i])];
    }
}

ll __qry(int l, int r){
    ll ans = 0;
    for(int i = l; i <= r; i ++){
        ans += __test[i];
    }
    return ans;
}

int main(){
    cin >> n >> q;
    for(int i = 1; i <= n; i ++){
        cin >> __test[i];
    }
    for(int i = 0; i < q; i ++){
        int t, l, r; cin >> t >> l >> r;
        if(t == 1) __upd(l, r);
        else cout << __qry(l, r) << endl;
    }
    /**
    /// cin >> n >> q;
    n = rand() % 100 + 1;
    q = rand() % 100 + 1;
    for(int i = 1; i <= n; i ++){
        int x;
        /// cin >> x;
        x = rand() % 100 + 1;

        __test[i] = x;

        put(1, 1, n, i, x);
    }
    for(int i = 0; i < q; i ++){
        int t, l, r;
        /// cin >> t >> l >> r;
        t = rand() % 3 + 1;
        r = rand() % (n - 1) + 2;
        l = rand() % r + 1;

        if(t == 1){
            upd(1, 1, n, l, r);
            __upd(l, r);
        }
        else{
            int ans = qry(1, 1, n, l, r).get(), __ans = qry(l, r);
            cout << ans << endl;
            cout << __ans << endl;
            if(ans != __ans){
                cin.get();
            }
        }
    }*/
}
/**
3 5
15 35 112
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3

50
279
246

*/
