#include<bits/stdc++.h>
using namespace std;

const int nmax=(1<<20)+42;

int n,q;

long long outp;

int SZ[nmax];
int shift[6][nmax];

struct info
{
    int lazy;
    long long sum[60];
};

info tree[2*nmax];

void push(int node)
{
    tree[node*2].lazy+=tree[node].lazy;
    tree[node*2+1].lazy+=tree[node].lazy;

    tree[node].lazy=0;
}

int pos(int val)
{
    return (val%60+60)%60;
}

void my_merge(int node)
{
    tree[node].lazy=0;

    for(int i=0;i<60;i++)
        tree[node].sum[i]=tree[node*2].sum[pos(i+tree[node*2].lazy)]+tree[node*2+1].sum[pos(i+tree[node*2+1].lazy)];

    //cout<<"my merge "<<node<<" -> ";for(int i=0;i<3;i++)cout<<tree[node].sum[i]<<" ";cout<<endl;
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        for(int j=0;j<60;j++)
            tree[node].sum[j]=shift[j%SZ[l]][l];

        return;
    }

    int av=(l+r)/2;

    build(node*2,l,av);
    build(node*2+1,av+1,r);

    for(int j=0;j<60;j++)
        tree[node].sum[j]=tree[node*2].sum[j]+tree[node*2+1].sum[j];
}

void update(int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)
    {
        //cout<<"update "<<node<<" "<<l<<" "<<r<<endl;

        tree[node].lazy++;
        return;
    }

    push(node);

    int av=(l+r)/2;

    if(lq<=av)update(node*2,l,av,lq,min(av,rq));
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq);

    my_merge(node);
}

void query(int node,int l,int r,int lq,int rq)
{
    if(l==lq&&r==rq)
    {
        outp+=tree[node].sum[tree[node].lazy%60];

        return;
    }

    push(node);

    int av=(l+r)/2;

    if(lq<=av)query(node*2,l,av,lq,min(av,rq));
    if(av<rq)query(node*2+1,av+1,r,max(av+1,lq),rq);

    my_merge(node);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin>>n>>q;

    for(int i=1;i<=n;i++)
    {
        string inp;

        cin>>inp;

        SZ[i]=inp.size();

        for(int j=0;j<SZ[i];j++)
        {
            int val=0;

            for(auto w:inp)
                val=val*10+w-'0';

            inp.insert(inp.begin(),inp.back());

            inp.pop_back();

            shift[j][i]=val;

            //cout<<j<<" -> "<<val<<endl;
        }
    }

    build(1,1,n);

    for(int i=1;i<=q;i++)
    {
        /*
        for(int l=1;l<=n;l++)
        {
            for(int r=l;r<=n;r++)
            {
                outp=0;

                query(1,1,n,l,r);

                cout<<l<<" "<<r<<" -> "<<outp<<endl;
            }
        }
        */

        int type,l,r;

        cin>>type>>l>>r;

        if(type==1)
        {
            update(1,1,n,l,r);
        }
        else
        {
            outp=0;

            query(1,1,n,l,r);

            cout<<outp<<"\n";
        }
    }

    return 0;
}
