#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6+1;
int a[MAXN];

struct Tel {
    long long l, r;
    Tel *ld, *rd;
    long long sumfr, suml;
    bool lazy;
};


void Build(Tel* k){
    k->lazy = 0;
    long long tl = k->l, tr = k->r;
    if(tl == tr) {
        k->ld = NULL;
        k->rd = NULL;
        k->sumfr = a[tl]/10;
        k->suml = a[tl]%10;
        return;
    }
    k->ld = new Tel;
    k->ld->l = tl; k->ld->r = (tl+tr)/2;
    Build(k->ld);
    k->rd = new Tel;
    k->rd->l = (tl+tr)/2+1;  k->rd->r = tr;
    Build(k->rd);
    k->sumfr = k->ld->sumfr + k->rd->sumfr;
    k->suml = k->ld->suml + k->rd->suml;
}

void pushLazy(Tel* k) {
    if(k->lazy) swap(k->sumfr, k->suml);
    if(k->ld != NULL) {
        (k->ld->lazy)^= k->lazy;
        (k->rd->lazy)^= k-> lazy;
    }
    k->lazy = 0;
}

void Update(int l, int r, Tel* k) {
    pushLazy(k);
    int tl = k->l, tr = k->r;
    if(tr < l || r < tl) return;
    if(l <= tl && tr <= r) {
        (k->lazy)^= 1;
        pushLazy(k);
    }
    else {
        Update(l, r, k->ld);
        Update(l, r, k->rd);
        k->sumfr = k->ld->sumfr + k->rd->sumfr;
        k->suml = k->ld->suml + k->rd->suml;
    }
}

long long Find(int l, int r, Tel* k) {
    pushLazy(k);
    int tl = k->l, tr = k->r;
    if(tr < l || r < tl) return 0;
    if(l <= tl && tr <= r) {
        return (k->sumfr)*10 + (k->suml);
    }
    else {
        return Find(l, r, k->ld) + Find(l, r, k->rd);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, q;
    cin>>n>>q;
    int i;
    for(i=1;i<=n;i++) cin>>a[i];

    Tel* root = new Tel;
    root->l = 1;  root->r = n;
    Build(root);

    while(q--) {
        int z, l, r;
        cin>>z>>l>>r;
        if(z == 1) {
            Update(l, r, root);
        }
        else
        if(z == 2) {
            cout<<Find(l, r, root)<<endl;
        }
    }


    return 0;
}
