#include<iostream>
#include<cmath>
using namespace std;

const int MAXN=1000000;
const int MAXNLOGN=1<<20;

int max2n;
int n,q;
int tree[MAXNLOGN+1];
int a[MAXN];
int digs[MAXN];

int dig(int x)
{
    if(x<10)return 1;
    return dig(x/10)+1;
}
void init()
{
    cin>>n>>q;
    max2n=log2(n)+1;
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        digs[i]=dig(a[i]);
    }
}
void build_tree(int i,int l)
{
    if(l==max2n)
    {
        tree[i]=a[i-(1<<(max2n))];
        return;
    }
    build_tree(2*i,l+1);
    build_tree(2*i+1,l+1);
    tree[i]=tree[2*i]+tree[2*i+1];
}
void print_tree()
{
    int lim=2;
    for(int i=1;i<(1<<(max2n+1));i++)
    {
        if(i==lim)
        {
            cout<<endl;
            lim<<=1;
        }
        cout<<tree[i]<<' ';
    }
    cout<<endl;
}
int get_sum(int l,int r)
{
    static int sum;
    l+=(1<<max2n)-1;
    r+=(1<<max2n)-1;
    sum=tree[l]+tree[r];
    while(l!=r)
    {
        if(l+1!=r)
        {
            if(l%2==0)
                sum+=tree[l+1];
            if(r%2==1)
                sum+=tree[r-1];
        }
        l/=2;
        r/=2;
    }
    return sum;
}
void rev(int i)
{
    int d=a[i]%10;
    a[i]/=10;
    for(int j=0;j<digs[i]-1;j++)
        d*=10;
    a[i]+=d;
}
void ch(int i,int x)
{
    i+=(1<<max2n);
    x-=tree[i];
    while(i>0)
    {
        tree[i]+=x;
        i/=2;
    }
}
void change()
{
    static int l,r;
    cin>>l>>r;
    l--;
    r--;
    for(int i=l;i<=r;i++)
    {
        rev(i);
        ch(i,a[i]);
    }
}
int sum()
{
    static int l,r;
    static int sum;
    cin>>l>>r;
    return get_sum(l,r);
}
int solve()
{
    static int command;
    cin>>command;
    if(command==2)return sum();
    change();
    return -1;
}

int main()
{
    int tmp;
    init();
    build_tree(1,0);
    for(int i=0;i<q;i++)
        if((tmp=solve())!=-1)
            cout<<tmp<<endl;
    return 0;
}
