#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+5, maxa = 3003, mod = 1e9+7;
int n, q;
long long d1 [maxa], d2 [maxa], sum;

bool notPrime [maxa];
vector <int> primes;
void findPrimes (){
    for (int i = 2; i < maxa; i ++){
        if (notPrime [i]) continue;
        primes.push_back (i);
        for (int j = i + i; j < maxa; j += i) notPrime [j] = 1;
    }
}

vector <pair <int, int> > divs, divs1;
void calcDivs (bool rm){
    int d = 1;
    for (auto p : divs1){
        for (int i = 0; i < p.second; i ++) d *= p.first;
    }
    if (!rm){
        d1 [d] = (d1 [d] + d2 [d]) % mod;
        sum += (long long) d * d2 [d];
        sum %= mod;
    }
    else{
        d2 [d] --;
        if (d2 [d] % 2) d2 [d] += mod;
        d2 [d] /= 2;
        d1 [d] = (d1 [d] + mod - d2 [d]) % mod;
        sum += mod - (long long) d * d2 [d] % mod;
        sum %= mod;
    }
    for (auto p : divs1){
        int dd = d / p.first;
        if (!rm){
            d1 [dd] = (d1 [dd] + mod - d2 [d]) % mod;
            sum += mod - (long long) dd * d2 [d] % mod;
            sum %= mod;
        }
        else{
            d1 [dd] = (d1 [dd] + d2 [d]) % mod;
            sum += (long long) dd * d2 [d];
            sum %= mod;
        }
    }
    if (!rm) d2 [d] = (d2 [d] * 2 + 1) % mod;
}
void cycleDivs (int pos, bool rm){
    if (pos == divs.size ()){
        calcDivs (rm);
        return;
    }
    cycleDivs (pos + 1, rm);
    divs1.push_back ({divs [pos].first, 1});
    int x = divs [pos].second;
    while (x --){
        cycleDivs (pos + 1, rm);
        divs1.back ().second ++;
    }
    divs1.pop_back ();
}

void addNumber (int a, bool rm){
    if (!rm){
        d1 [a] ++;
        d1 [a] %= mod;
        sum += a;
        sum %= mod;
    }
    else{
        d1 [a] += mod - 1;
        d1 [a] %= mod;
        sum += mod - a;
        sum %= mod;
    }
    divs.clear ();
    divs1.clear ();
    for (int i : primes){
        if (a % i > 0) continue;
        divs.push_back ({i, 0});
        while (a % i == 0){
            divs.back ().second ++;
            a /= i;
        }
        if (a > 1 && !notPrime [a]){
            divs.push_back ({a, 1});
            a = 1;
        }
        if (a == 1) break;
    }
    cycleDivs (0, rm);
}

void addNumberBruteforce (int a){
    for (int i = 1; i < maxa; i ++){
        int gcd = __gcd (a, i);
        sum += d1 [i] * gcd;
        sum %= mod;
        d1 [gcd] += d1 [i];
        d1 [gcd] %= mod;
    }
    d1 [a] ++;
    d1 [a] %= mod;
    sum += a;
    sum %= mod;
}
void removeNumberBruteforce (int a){
    d1 [a] += mod - 1;
    d1 [a] %= mod;
    sum += mod - a;
    sum %= mod;
    for (int i = maxa - 1; i >= 1; i --){
        int gcd = __gcd (a, i);
        if (gcd == i){
            if (d1 [i] % 2) d1 [i] += mod;
            d1 [i] /= 2;
            sum += mod - d1 [i] * gcd % mod;
            sum %= mod;
        }
        else{
            d1 [gcd] += mod - d1 [i];
            d1 [gcd] %= mod;
            sum += mod - d1 [i] * gcd % mod;
            sum %= mod;
        }
    }
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    findPrimes ();

    cin >> n >> q;
    for (int i = 0; i < n; i ++){
        int a;
        cin >> a;
        addNumberBruteforce (a);
    }
    cout << sum << '\n';
    while (q --){
        int t, a;
        cin >> t >> a;
        if (t == 1) addNumberBruteforce (a);
        else removeNumberBruteforce (a);
        cout << sum << '\n';
    }

}
