#include <bits/stdc++.h>
using namespace std;

const int maxn = 1050006, maxq = 50004, maxd = 6;
int n, q, a [maxn];
int tree [2 * maxn][maxd][maxd], lazy [2 * maxn];
void build (int l, int r, int pos){
    if (l == r){
        int x = a [l], cntDig = 0, posDig = 0;
        while (x > 0){
            x /= 10;
            cntDig ++;
        }
        x = a [l];
        while (x > 0){
            tree [pos][cntDig - 1][posDig] += x % 10;
            x /= 10;
            posDig ++;
        }
        return;
    }
    int mid = l + r >> 1;
    build (l, mid, pos << 1);
    build (mid + 1, r, pos << 1 | 1);
    for (int i = 0; i < maxd; i ++){
        for (int j = 0; j < maxd; j ++){
            tree [pos][i][j] = tree [pos << 1][i][j] + tree [pos << 1 | 1][i][j];
        }
    }
}
void updLazy (int l, int r, int pos){
    if (!lazy [pos]) return;
    for (int cntDig = 2; cntDig <= maxd; cntDig ++){
        int l = lazy [pos] % cntDig;
        vector <int> digs;
        for (int posDig = 0; posDig < cntDig; posDig ++){
            digs.push_back (tree [pos][cntDig - 1][(posDig + l) % cntDig]);
        }
        for (int posDig = 0; posDig < cntDig; posDig ++){
            tree [pos][cntDig - 1][posDig] = digs [posDig];
        }
    }
    if (l != r){
        lazy [pos << 1] += lazy [pos];
        lazy [pos << 1 | 1] += lazy [pos];
    }
    lazy [pos] = 0;
}
void upd (int l, int r, int pos, int ql, int qr){
    updLazy (l, r, pos);
    if (l >= ql && r <= qr){
        lazy [pos] ++;
        updLazy (l, r, pos);
        return;
    }
    if (l > qr || r < ql) return;
    int mid = l + r >> 1;
    upd (l, mid, pos << 1, ql, qr);
    upd (mid + 1, r, pos << 1 | 1, ql, qr);
    for (int i = 0; i < maxd; i ++){
        for (int j = 0; j < maxd; j ++){
            tree [pos][i][j] = tree [pos << 1][i][j] + tree [pos << 1 | 1][i][j];
        }
    }
}
long long query (int l, int r, int pos, int ql, int qr){
    updLazy (l, r, pos);
    if (l >= ql && r <= qr){
        long long ans = 0;
        for (int cntDig = 1; cntDig <= maxd; cntDig ++){
            long long mult = 1;
            for (int posDig = 0; posDig < cntDig; posDig ++){
                ans += (long long) tree [pos][cntDig - 1][posDig] * mult;
                mult *= 10;
            }
        }
        return ans;
    }
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, pos << 1 | 1, ql, qr);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> q;
    for (int i = 0; i < n; i ++) cin >> a [i];
    build (0, n - 1, 1);
    while (q --){
        int t, l, r;
        cin >> t >> l >> r;
        if (t == 1) upd (0, n - 1, 1, l - 1, r - 1);
        else cout << query (0, n - 1, 1, l - 1, r - 1) << '\n';
    }

}
