#include<iostream>
using namespace std;

struct num
{
    long long l;
    long long d[6];
};

num nums[2000000];

struct node
{
    long long val[2];
    long long val2d[6][6];
    bool rot=false;
    long long rot2d=0;
};

node tree[4000000];

void updateNode(long long l, long long r, long long i)
{

    while(tree[i].rot2d>0)
    {
        tree[i].rot2d--;
        for(long long p=0; p<5; p++)
        {
            for(long long j=0; j<p; j++)
            {
                swap(tree[i].val2d[p][j],tree[i].val2d[p][j+1]);
            }
        }
        tree[i*2].rot2d++;
        tree[i*2+1].rot2d++;
    }


    tree[i].rot=false;
    swap(tree[i].val[0], tree[i].val[1]);

    if(l!=r)
    {
        tree[i*2].rot=!tree[i*2].rot;
        tree[i*2+1].rot=!tree[i*2+1].rot;
    }
}

void updateSum(long long l, long long r, long long i)
{
    for(long long p=0; p<5; p++)
    {
        for(long long j=0; j<=p; j++)
        {
            tree[i].val2d[p][j]=tree[i*2].val2d[p][j]+tree[i*2+1].val2d[p][j];
        }
    }

    tree[i].val[0]=tree[i*2].val[0]+tree[i*2+1].val[0];
    tree[i].val[1]=tree[i*2].val[1]+tree[i*2+1].val[1];
}

void bld(long long l, long long r, long long i)
{
    if(l==r)
    {
        long long cnt=nums[l].l;
        for(long long p=0; p<cnt; p++)
        {
            tree[i].val2d[cnt-1][p]=nums[l].d[p];
        }

        tree[i].val[0]=nums[l].d[0];
        tree[i].val[1]=nums[l].d[1];
        return;
    }
    long long m=(l+r)/2;
    bld(l, m, i*2);
    bld(m+1, r, i*2+1);
    updateSum(l, r, i);
}

void upd(long long l, long long r, long long i, long long ql, long long qr)
{
    if(tree[i].rot2d)
    {
        updateNode(l, r, i);
    }
    if(l>=ql && r<=qr)
    {
        tree[i].rot2d++;
        updateNode(l, r, i);
        return;
    }
    if(r<ql || l>qr)
    {
        return;
    }
    long long m=(l+r)/2;
    upd(l, m, i*2, ql, qr);
    upd(m+1, r, i*2+1, ql, qr);
    updateSum(l, r, i);
}

long long query(long long l, long long r, long long i, long long ql, long long qr)
{
    if(tree[i].rot2d)
    {
        updateNode(l, r, i);
    }
    if(l>=ql && r<=qr)
    {
        long long sum=0;
        for(long long p=0; p<5; p++)
        {
            long long mult=1;
            for(long long j=0; j<=p; j++)
            {
                sum+=tree[i].val2d[p][j]*mult;
                mult*=10;
            }
        }
        return sum;
        //return tree[i].val[0]+tree[i].val[1]*10;
    }
    if(r<ql || l>qr)
    {
        return 0;
    }
    long long m=(l+r)/2;
    long long sum=0;
    sum+=query(l, m, i*2, ql, qr);
    sum+=query(m+1, r, i*2+1, ql, qr);
    updateSum(l, r, i);
    return sum;
}

void prnt(long long n){
    for(long long i=1;i<=n*2;i++){
        for(long long p=0; p<5; p++)
        {
            long long mult=1;
            for(long long j=0; j<=p; j++)
            {
                cout<<tree[i].val2d[p][j]<<" ";
            }
            cout<<endl;
        }
        cout<<endl;
    }
}
int main()
{
    long long n,q;
    cin>>n>>q;
    for(long long i=0; i<n; i++)
    {
        long long a;
        cin>>a;
        while(a>0)
        {
            nums[i].d[nums[i].l]=a%10;
            a/=10;
            nums[i].l++;
        }
    }

    bld(0, n-1, 1);

    //prnt(n);

    for(long long i=0; i<q; i++)
    {
        long long t, l, r;
        cin>>t>>l>>r;
        l--;
        r--;
        if(t==1)
        {
            upd(0, n-1, 1, l, r);
            //prnt(n);
        }
        else
        {
            cout<<query(0, n-1, 1, l, r)<<endl;
        }
    }

    return 0;
}
