#include <bits/stdc++.h>
using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

#define endl "\n"
#define out(x) "[" << #x << "=" << x << "]"

template<class T, class T2>
ostream& operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T>
ostream& operator <<(ostream &out, const vector<T> &x) {
    for(const auto &it : x) {
        out << it << " ";
    }
    return out;
}

struct debug {
    debug() { cerr << "->"; }
    ~debug() { cerr << endl; }

    template<class T>
    debug &operator <<(const T &x) {
        cerr << x << " ";
        return *this;
    }
};
#define dbg debug()

template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }

typedef long long ll;

const ll mod = 1e9 + 7;
const ll half = (mod + 1) / 2ll;
///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 3e3 + 10;
ll sum[MAX_N];
ll mo[MAX_N];
bool prime[MAX_N];
ll n, q;
vector<int> divis[MAX_N];
ll start[MAX_N];

void add(int x) {
    for(auto it : divis[x]) {
        start[it] = (start[it] * 2 + 1) % mod;
    }
}

void remove(int x) {
    for(auto it : divis[x]) {
        start[it] = (start[it] - 1ll + mod) * half % mod;
    }
}

void calculate() {
    for(ll i = 1; i < MAX_N; i ++) {
        sum[i] = 0;
        for(ll j = 1; j * i < MAX_N; j ++) {
            sum[i] += mo[j] * start[j * i] % mod;
            sum[i] = (sum[i] % mod + mod) % mod;
        }
    }

    ll ret = 0;
    for(ll i = 1; i < MAX_N; i ++) {
        ret = (ret + (i * sum[i] % mod)) % mod;
    }

    cout << ret << endl;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    fill_n(mo, MAX_N, 1);

    divis[1].push_back(1);
    for(ll i = 2; i < MAX_N; i ++) {
        divis[i].push_back(1);
        divis[i].push_back(i);

        if(!prime[i]) {
            mo[i] = -1;
        }

        for(ll j = 2 * i; j < MAX_N; j += i) {
            divis[j].push_back(i);
            prime[j] = true;

            if(!prime[i]) {
                mo[j] *= -1;
            }
        }
        for(ll j = i * i; j < MAX_N; j += i * i) {
            mo[j] = 0;
        }
    }

    cin >> n >> q;
    for(ll i = 0; i < n; i ++) {
        ll x;
        cin >> x;
        add(x);
    }

    calculate();

    while(q --) {
        int t;
        cin >> t;
        if(t == 1) {
            int x;
            cin >> x;
            add(x);
            calculate();
        } else {
            int x;
            cin >> x;
            remove(x);
            calculate();
        }
    }

    return 0;
}


