#include <bits/stdc++.h>
using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

#define endl "\n"
#define out(x) "[" << #x << "=" << x << "]"

template<class T, class T2>
ostream& operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T>
ostream& operator <<(ostream &out, const vector<T> &x) {
    for(const auto &it : x) {
        out << it << " ";
    }
    return out;
}

struct debug {
    debug() { cerr << "->"; }
    ~debug() { cerr << endl; }

    template<class T>
    debug &operator <<(const T &x) {
        cerr << x << " ";
        return *this;
    }
};
#define dbg debug()

template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_STATE = 60;

struct Node {
    ll sum[MAX_STATE];
    ll lazy;

    Node() {
        for(int i = 0; i < MAX_STATE; i ++) {
            sum[i] = 0;
        }
        lazy = 0;
    }

    Node(int x) {
        ll pw = 1;
        while(pw * 10 < x) {
            pw *= 10;
        }

        sum[0] = x;
        for(int i = 1; i < MAX_STATE; i ++) {
            ll big = sum[i - 1] / pw;
            sum[i] = sum[i - 1] / 10 + sum[i - 1] % 10 * pw;
        }

        lazy = 0;
    }
};

Node operator +(const Node &a, const Node &b) {
    Node ret;

    for(int i = 0; i < MAX_STATE; i ++) {
        ret.sum[i] = (a.sum[i] + b.sum[i]);
    }

    return ret;
}

const int MAX_N = 1 << 20;
struct SegTree {
    Node tree[2 * MAX_N];

    void build(int curr, int l, int r, int arr[]) {
        if(l == r) {
            tree[curr] = Node(arr[l]);
            return;
        }
        int m = (l + r) / 2ll;
        build(curr * 2, l, m, arr);
        build(curr * 2 + 1, m + 1, r, arr);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    void push(int curr, int l, int r) {
        tree[curr].lazy %= MAX_STATE;
        if(tree[curr].lazy == 0) {return;}
        int lazy = tree[curr].lazy;
        Node nw;

        for(int i = 0; i < MAX_STATE; i ++) {
            nw.sum[(i + MAX_STATE - lazy) % MAX_STATE] = tree[curr].sum[i];
        }
        tree[curr] = nw;

        if(l != r) {
            tree[curr * 2].lazy += lazy;
            tree[curr * 2 + 1].lazy += lazy;
        }
    }

    ll sum(int curr, int l, int r, int ql, int qr) {
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            return tree[curr].sum[0];
        } else if(l > qr || r < ql) {return 0;}

        int m = (l + r) / 2ll;

        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }

    void upd(int curr, int l, int r, int ql, int qr) {
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            tree[curr].lazy ++;
            push(curr, l, r);
            return;
        } else if(l > qr || r < ql) {return;}
        int m = (l + r) / 2ll;

        upd(curr * 2, l, m, ql, qr);
        upd(curr * 2 + 1, m + 1, r, ql, qr);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }
};

SegTree st;
int arr[MAX_N];
int n, q;

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    st.build(1, 0, MAX_N - 1, arr);

    while(q --) {
        int t;
        cin >> t;
        if(t == 1) {
            int l, r;
            cin >> l >> r;
            l --; r --;
            st.upd(1, 0, MAX_N - 1, l, r);
        } else {
            int l, r;
            cin >> l >> r;
            l --; r --;
            cout << st.sum(1, 0, MAX_N - 1, l, r) << endl;
        }
    }

    return 0;
}

