#include<iostream>
#include<vector>
using namespace std;

int broiChisla;
int broiZaqvki;

int chisla[1000010];

int broiCifri(int chi){
    int br = 0;

    while(chi > 0){
        chi /= 10;
        br++;
    }

    return br;
}

int rotateniChisloto(int chi){
    int poslCifra = chi%10;
    chi /= 10;

    int brCifr = broiCifri(chi);

    int desetNaStepenta = 1;

    for(int i = 0; i < brCifr; i++){
        desetNaStepenta *= 10;
    }

    chi = poslCifra*desetNaStepenta + chi;

    return chi;
}

struct DanniZaVarha{
    int stoinost;
    int otKadeObhvashta;
    int doKadeObhvashta;
    int lqvoDete;
    int dqsnoDete;
};

vector<DanniZaVarha> varhove;
int korenNomer = -1;

int daiNovVrah(DanniZaVarha novVrah){
    varhove.push_back(novVrah);
    return varhove.size() - 1;
}

int napraviDarvo(int otKade, int doKade){
    if(otKade == doKade){
        return daiNovVrah({chisla[otKade], otKade, doKade, -1, -1});
    }

    int lqvoDete = napraviDarvo(otKade, (otKade + doKade)/2);
    int dqsnoDete = napraviDarvo((otKade + doKade)/2 + 1, doKade);

    return daiNovVrah({varhove[lqvoDete].stoinost + varhove[dqsnoDete].stoinost, otKade, doKade, lqvoDete, dqsnoDete});

}

void updateEdin(int segashenVrah, int koiEdin){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > koiEdin ||
        varhove[segashenVrah].doKadeObhvashta < koiEdin)
    {
        return ;
    }

    if(koiEdin <= varhove[segashenVrah].otKadeObhvashta && koiEdin >= varhove[segashenVrah].doKadeObhvashta){
        varhove[segashenVrah].stoinost = rotateniChisloto(varhove[segashenVrah].stoinost);
        return ;
    }

    updateEdin(varhove[segashenVrah].lqvoDete, koiEdin);
    updateEdin(varhove[segashenVrah].dqsnoDete, koiEdin);

    varhove[segashenVrah].stoinost =
        varhove[varhove[segashenVrah].lqvoDete].stoinost +
        varhove[varhove[segashenVrah].dqsnoDete].stoinost;
}

int queryMnogo(int segashenVrah, int otKade, int doKade){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > doKade ||
        varhove[segashenVrah].doKadeObhvashta < otKade)
    {
        return 0;
    }

    if(otKade <= varhove[segashenVrah].otKadeObhvashta && doKade >= varhove[segashenVrah].doKadeObhvashta){
        return varhove[segashenVrah].stoinost;
    }

    return queryMnogo(varhove[segashenVrah].lqvoDete, otKade, doKade) +
                queryMnogo(varhove[segashenVrah].dqsnoDete, otKade, doKade);
}

vector<int> otgovori;

int main(){

    cin>>broiChisla>>broiZaqvki;

    for(int i = 0; i < broiChisla; i++){
        cin>>chisla[i];
    }

    if(broiChisla <= 5000 && broiZaqvki <= 5000){
        for(int i = 0; i < broiZaqvki; i++){
            int tip;
            int otKade;
            int doKade;
            cin>>tip>>otKade>>doKade;

            otKade--;
            doKade--;

            if(tip == 1){
                for(int j = otKade; j <= doKade; j++){
                    chisla[j] = rotateniChisloto(chisla[j]);
                }
            }else{
                int suma = 0;
                for(int j = otKade; j <= doKade; j++){
                    suma += chisla[j];
                }

                otgovori.push_back(suma);
            }
        }
    }else{
        korenNomer = napraviDarvo(0, broiChisla - 1);

        for(int i = 0; i < broiZaqvki; i++){
            int tip;
            int otKade;
            int doKade;
            cin>>tip>>otKade>>doKade;

            otKade--;
            doKade--;

            if(tip == 1){
                updateEdin(korenNomer, otKade);
            }else{
                int tukaSuma = queryMnogo(korenNomer, otKade, doKade);
                otgovori.push_back(tukaSuma);
            }
        }
    }

    for(int i = 0; i < (int)otgovori.size(); i++){
        cout<<otgovori[i]<<endl;
    }

    return 0;
}
