#include<iostream>
#include<vector>
using namespace std;

long long broiChisla;
long long broiZaqvki;

long long chisla[1000010];

struct DanniZaZaqvkata{
    long long tip;
    long long otKade;
    long long doKade;
};

DanniZaZaqvkata zaqvki[50010];

long long broiCifri(long long chi){
    long long br = 0;

    while(chi > 0){
        chi /= 10;
        br++;
    }

    return br;
}

long long rotateniChisloto(long long chi){
    long long poslCifra = chi%10;
    chi /= 10;

    long long brCifr = broiCifri(chi);

    long long desetNaStepenta = 1;

    for(long long i = 0; i < brCifr; i++){
        desetNaStepenta *= 10;
    }

    chi = poslCifra*desetNaStepenta + chi;

    return chi;
}

struct DanniZaVarha{
    long long stoinost;
    long long lazyStoinost;
    long long otKadeObhvashta;
    long long doKadeObhvashta;
    long long lqvoDete;
    long long dqsnoDete;
};

vector<DanniZaVarha> varhove;
long long korenNomer = -1;

long long daiNovVrah(DanniZaVarha novVrah){
    varhove.push_back(novVrah);
    return varhove.size() - 1;
}

long long napraviDarvo(long long otKade, long long doKade){
    if(otKade == doKade){
        return daiNovVrah({chisla[otKade], 0, otKade, doKade, -1, -1});
    }

    long long lqvoDete = napraviDarvo(otKade, (otKade + doKade)/2);
    long long dqsnoDete = napraviDarvo((otKade + doKade)/2 + 1, doKade);

    return daiNovVrah({varhove[lqvoDete].stoinost + varhove[dqsnoDete].stoinost, 0, otKade, doKade, lqvoDete, dqsnoDete});

}

void updateEdin(long long segashenVrah, long long koiEdin){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > koiEdin ||
        varhove[segashenVrah].doKadeObhvashta < koiEdin)
    {
        return ;
    }

    if(koiEdin <= varhove[segashenVrah].otKadeObhvashta && koiEdin >= varhove[segashenVrah].doKadeObhvashta){
        varhove[segashenVrah].stoinost = rotateniChisloto(varhove[segashenVrah].stoinost);
        return ;
    }

    updateEdin(varhove[segashenVrah].lqvoDete, koiEdin);
    updateEdin(varhove[segashenVrah].dqsnoDete, koiEdin);

    varhove[segashenVrah].stoinost =
        varhove[varhove[segashenVrah].lqvoDete].stoinost +
        varhove[varhove[segashenVrah].dqsnoDete].stoinost;
}

long long queryMnogo(long long segashenVrah, long long otKade, long long doKade){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > doKade ||
        varhove[segashenVrah].doKadeObhvashta < otKade)
    {
        return 0;
    }

    if(otKade <= varhove[segashenVrah].otKadeObhvashta && doKade >= varhove[segashenVrah].doKadeObhvashta){
        return varhove[segashenVrah].stoinost;
    }

    return queryMnogo(varhove[segashenVrah].lqvoDete, otKade, doKade) +
                queryMnogo(varhove[segashenVrah].dqsnoDete, otKade, doKade);
}

void updateMnogo(long long segashenVrah, long long otKade, long long doKade){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > doKade ||
        varhove[segashenVrah].doKadeObhvashta < otKade)
    {
        return ;
    }

    if(otKade <= varhove[segashenVrah].otKadeObhvashta && doKade >= varhove[segashenVrah].doKadeObhvashta){
        varhove[segashenVrah].lazyStoinost++;
        /*if(varhove[segashenVrah].lqvoDete != -1 && varhove[segashenVrah].dqsnoDete != -1){
            varhove[varhove[segashenVrah].lqvoDete].lazyStoinost++;
            varhove[varhove[segashenVrah].dqsnoDete].lazyStoinost++;
            varhove[segashenVrah].lazyStoinost = 0;
        }*/

        return ;
    }

    updateMnogo(varhove[segashenVrah].lqvoDete, otKade, doKade);
    updateMnogo(varhove[segashenVrah].dqsnoDete, otKade, doKade);
}

long long queryEdin(long long segashenVrah, long long koiEdin){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > koiEdin ||
        varhove[segashenVrah].doKadeObhvashta < koiEdin)
    {
        return 0;
    }

    if(koiEdin <= varhove[segashenVrah].otKadeObhvashta && koiEdin >= varhove[segashenVrah].doKadeObhvashta){
        for(long long i = 0; i < varhove[segashenVrah].lazyStoinost; i++){
            varhove[segashenVrah].stoinost = rotateniChisloto(varhove[segashenVrah].stoinost);
        }
        varhove[segashenVrah].lazyStoinost = 0;
        return varhove[segashenVrah].stoinost;
    }

    if(varhove[segashenVrah].lazyStoinost != 0){
        if(varhove[segashenVrah].lqvoDete != -1 && varhove[segashenVrah].dqsnoDete != -1){
            varhove[varhove[segashenVrah].lqvoDete].lazyStoinost += varhove[segashenVrah].lazyStoinost;
            varhove[varhove[segashenVrah].dqsnoDete].lazyStoinost += varhove[segashenVrah].lazyStoinost;
            varhove[segashenVrah].lazyStoinost = 0;
        }
    }

    return queryEdin(varhove[segashenVrah].lqvoDete, koiEdin) + queryEdin(varhove[segashenVrah].dqsnoDete, koiEdin);
}

long long dobroQueryMnogo(long long segashenVrah, long long otKade, long long doKade){
    if(segashenVrah == -1 ||
        varhove[segashenVrah].otKadeObhvashta > doKade ||
        varhove[segashenVrah].doKadeObhvashta < otKade)
    {
        return 0;
    }

    if(varhove[segashenVrah].lqvoDete == -1 && varhove[segashenVrah].dqsnoDete == -1){
        for(long long i = 0; i < varhove[segashenVrah].lazyStoinost%2; i++){
            varhove[segashenVrah].stoinost = rotateniChisloto(varhove[segashenVrah].stoinost);
        }
        varhove[segashenVrah].lazyStoinost = 0;
        return varhove[segashenVrah].stoinost;
    }

    if(varhove[segashenVrah].lazyStoinost != 0){
        if(varhove[segashenVrah].lqvoDete != -1 && varhove[segashenVrah].dqsnoDete != -1){
            varhove[varhove[segashenVrah].lqvoDete].lazyStoinost += varhove[segashenVrah].lazyStoinost;
            varhove[varhove[segashenVrah].dqsnoDete].lazyStoinost += varhove[segashenVrah].lazyStoinost;
            varhove[segashenVrah].lazyStoinost = 0;
        }
    }

    return dobroQueryMnogo(varhove[segashenVrah].lqvoDete, otKade, doKade) +
                dobroQueryMnogo(varhove[segashenVrah].dqsnoDete, otKade, doKade);
}

vector<long long> otgovori;

int main(){

    cin>>broiChisla>>broiZaqvki;

    for(long long i = 0; i < broiChisla; i++){
        cin>>chisla[i];
    }

    if(broiChisla <= 5000 && broiZaqvki <= 5000){
        for(long long i = 0; i < broiZaqvki; i++){
            long long tip;
            long long otKade;
            long long doKade;
            cin>>tip>>otKade>>doKade;

            otKade--;
            doKade--;

            if(tip == 1){
                for(long long j = otKade; j <= doKade; j++){
                    chisla[j] = rotateniChisloto(chisla[j]);
                }
            }else{
                long long suma = 0;
                for(long long j = otKade; j <= doKade; j++){
                    suma += chisla[j];
                }

                otgovori.push_back(suma);
            }
        }
    }else{
        korenNomer = napraviDarvo(0, broiChisla - 1);

        bool updatevameEdinLi = true;

        for(long long i = 0; i < broiZaqvki; i++){
            long long tip;
            long long otKade;
            long long doKade;
            cin>>tip>>otKade>>doKade;

            otKade--;
            doKade--;

            if(tip == 1 && otKade != doKade){
                updatevameEdinLi = false;
            }

            zaqvki[i] = {tip, otKade, doKade};
        }

        for(long long i = 0; i < broiZaqvki; i++){

            long long tip = zaqvki[i].tip;
            long long otKade = zaqvki[i].otKade;
            long long doKade = zaqvki[i].doKade;

            if(tip == 1){
                /*if(updatevameEdinLi == true){
                    updateEdin(korenNomer, otKade);
                }else{
                    updateMnogo(korenNomer, otKade, doKade);
                }*/
                updateMnogo(korenNomer, otKade, doKade);
            }else{
                long long tukaSuma = 0;
                /*if(updatevameEdinLi == true){
                    tukaSuma = queryMnogo(korenNomer, otKade, doKade);
                }else{
                    tukaSuma = queryEdin(korenNomer, otKade);
                }*/
                tukaSuma = dobroQueryMnogo(korenNomer, otKade, doKade);
                otgovori.push_back(tukaSuma);
            }
        }
    }

    for(long long i = 0; i < (long long)otgovori.size(); i++){
        cout<<otgovori[i]<<endl;
    }

    return 0;
}
