#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const int N = 1e6 + 10;
int a[N], sz[N], pw[8] = {1, 10, 100, 1e3, 1e4, 1e5, 1e6, 1e7};
int tree[4 * N];

void build(int root, int l, int r)
{
    if(l == r) tree[root] = a[l];
    else
    {
        int mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);
        tree[root] = tree[root * 2] + tree[root * 2 + 1];
    }
}

void update(int root, int l, int r, int x)
{
    if(l == r)
    {
        int tmp = tree[root] % 10;
        tree[root] /= 10;
        tree[root] += tmp * pw[sz[l] - 1];
    }
    else
    {
        int mid = (l + r) / 2;
        if(x <= mid) update(root * 2, l, mid, x);
        else update(root * 2 + 1, mid + 1, r, x);
        tree[root] = tree[root * 2] + tree[root * 2 + 1];
    }
}

int query(int root, int l, int r, int ql, int qr)
{
    if(l == ql && r == qr) return tree[root];
    else
    {
        int mid = (l + r) / 2;
        if(qr <= mid) return query(root * 2, l, mid, ql, qr);
        if(ql > mid) return query(root * 2 + 1, mid + 1, r, ql, qr);
        return query(root * 2, l, mid, ql, mid) + query(root * 2 + 1, mid + 1, r, mid + 1, qr);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, q, tmp, t, l, r;
	cin >> n >> q;
	for(int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        tmp = a[i];
        while(tmp) sz[i]++, tmp /= 10;
    }
	build(1, 1, n);
	while(q--)
    {
        cin >> t;
        if(t == 1) cin >> l >> r, update(1, 1, n, r);
        else cin >> l >> r, cout << query(1, 1, n, l, r) << endl;
    }
	return 0;
}
