#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const long long N = 1e6 + 10;
long long a[N], sz[N], pw[8] = {1, 10, 100, 1e3, 1e4, 1e5, 1e6, 1e7};
long long tree[4 * N];

void build(long long root, long long l, long long r)
{
    if(l == r) tree[root] = a[l];
    else
    {
        long long mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);
        tree[root] = tree[root * 2] + tree[root * 2 + 1];
    }
}

void update(long long root, long long l, long long r, long long x)
{
    if(l == r)
    {
        long long tmp = tree[root] % 10;
        tree[root] /= 10;
        tree[root] += tmp * pw[sz[l] - 1];
    }
    else
    {
        long long mid = (l + r) / 2;
        if(x <= mid) update(root * 2, l, mid, x);
        else update(root * 2 + 1, mid + 1, r, x);
        tree[root] = tree[root * 2] + tree[root * 2 + 1];
    }
}

long long query(long long root, long long l, long long r, long long ql, long long qr)
{
    if(l == ql && r == qr) return tree[root];
    else
    {
        long long mid = (l + r) / 2;
        if(qr <= mid) return query(root * 2, l, mid, ql, qr);
        if(ql > mid) return query(root * 2 + 1, mid + 1, r, ql, qr);
        return query(root * 2, l, mid, ql, mid) + query(root * 2 + 1, mid + 1, r, mid + 1, qr);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long n, q, tmp, t, l, r;
	cin >> n >> q;
	for(long long i = 1; i <= n; ++i)
    {
        cin >> a[i];
        tmp = a[i];
        while(tmp) sz[i]++, tmp /= 10;
    }
	build(1, 1, n);
	while(q--)
    {
        cin >> t;
        if(t == 1) cin >> l >> r, update(1, 1, n, l);
        else cin >> l >> r, cout << query(1, 1, n, l, r) << endl;
    }
	return 0;
}
