#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const long long N = 1e6 + 10, K = 16;
long long a[N], sz[N], pw[16] = {1, 10, 100, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9, 1e10, 1e11, 1e12, 1e13, 1e14, 1e15};
long long tree[4 * N][16], lazy[4 * N];

void build(long long root, long long l, long long r)
{
    if(l == r)
    {
        long long tmp = a[l], i = 0;
        while(tmp) tree[root][i] = tmp % 10, tmp /= 10, i++;
        //tree[root] = a[l];
    }
    else
    {
        long long mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);

        for(long long i = 0; i < K; ++i) tree[root][i] = tree[root * 2][i] + tree[root * 2 + 1][i];
        //tree[root] = tree[root * 2] + tree[root * 2 + 1];
    }
}

void update1(long long root, long long l, long long r, long long x)
{
    if(l == r)
    {
        long long tmp = tree[root][0];
        for(long long i = 1; i < K; ++i)
        {
            if(tree[root][i] == 0)
            {
                tree[root][i - 1] = tmp;
                break;
            }
            tree[root][i - 1] = tree[root][i];
        }
        //tree[root] /= 10;
        //tree[root] += tmp * pw[sz[l] - 1];
    }
    else
    {
        long long mid = (l + r) / 2;
        if(x <= mid) update1(root * 2, l, mid, x);
        else update1(root * 2 + 1, mid + 1, r, x);

        for(long long i = 0; i < K; ++i) tree[root][i] = tree[root * 2][i] + tree[root * 2 + 1][i];
    }
}

void push(long long root)
{
    long long SZ = 0, rot = lazy[root];
    for(long long i = 0; i < K; ++i) if(tree[root][i]) SZ++;
    rot %= SZ;
    for(long long k = 0; k < rot; ++k)
    {
        long long tmp = tree[root][0];
        for(long long i = 1; i < K; ++i)
        {
            if(tree[root][i] == 0)
            {
                tree[root][i - 1] = tmp;
                break;
            }
            tree[root][i - 1] = tree[root][i];
        }
    }
    lazy[root * 2] += lazy[root];
    lazy[root * 2 + 1] += lazy[root];
    lazy[root] = 0;
}

void update2(long long root, long long l, long long r, long long ql, long long qr)
{
    //cout << l << " " << r << " " << ql << " " << qr << endl;
    push(root);
    if(l == ql && r == qr)
    {
        lazy[root]++;
        push(root);
        /*long long SZ = 0, rot = lazy[root];
        for(long long i = 0; i < K; ++i) if(tree[root][i]) SZ++;
        //rot %= SZ;
        ///cout << rot << " " << SZ << " " << rot % SZ << endl;
        rot %= SZ;
        for(long long k = 0; k < rot; ++k)
        {
            long long tmp = tree[root][0];
            for(long long i = 1; i < K; ++i)
            {
                if(tree[root][i] == 0)
                {
                    tree[root][i - 1] = tmp;
                    break;
                }
                tree[root][i - 1] = tree[root][i];
            }
        }
        lazy[root * 2] += lazy[root];
        lazy[root * 2 + 1] += lazy[root];
        lazy[root] = 0;*/
    }
    else
    {
        //push(root);
        long long mid = (l + r) / 2;
        if(qr <= mid) update2(root * 2, l, mid, ql, qr);
        else if(ql > mid) update2(root * 2 + 1, mid + 1, r, ql, qr);
        else update2(root * 2, l, mid, ql, mid), update2(root * 2 + 1, mid + 1, r, mid + 1, qr);

        for(long long i = 0; i < K; ++i) tree[root][i] = tree[root * 2][i] + tree[root * 2 + 1][i];
    }
}

long long query(long long root, long long l, long long r, long long ql, long long qr)
{
    push(root);
    if(l == ql && r == qr)
    {
        long long ans = 0;
        for(long long i = 0; i < K; ++i) ans += tree[root][i] * pw[i];
        return ans;
    }
    else
    {

        long long mid = (l + r) / 2;
        if(qr <= mid) return query(root * 2, l, mid, ql, qr);
        if(ql > mid) return query(root * 2 + 1, mid + 1, r, ql, qr);
        return query(root * 2, l, mid, ql, mid) + query(root * 2 + 1, mid + 1, r, mid + 1, qr);
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);

    long long n, q, tmp, t, l, r;
    cin >> n >> q;
    for(long long i = 1; i <= n; ++i)
    {
        cin >> a[i];
        tmp = a[i];
        while(tmp) sz[i]++, tmp /= 10;
    }
    build(1, 1, n);
    while(q--)
    {
        cin >> t;
        if(t == 1)
        {
            cin >> l >> r;
            //if(l == r) update1(1, 1, n, l);
            //else
                update2(1, 1, n, l, r);
        }
        else cin >> l >> r, cout << query(1, 1, n, l, r) << endl;
        //cout << "TREE" << endl << "--------------------------" << endl;
        //for(long long i = 1; i <= 8; ++i, cout << endl)
        //    for(long long j = 0; j <= 4; ++j) cout << tree[i][j] << " ";
    }
    return 0;
}
