#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const long long N = 1e6 + 10, K = 16;
long long a[N], sz[N], pw[16] = {1, 10, 100, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9, 1e10, 1e11, 1e12, 1e13, 1e14, 1e15};
long long tree[8 * N][16], lazy[8 * N];

void build(long long root, long long l, long long r)
{
    if(l == r)
    {
        long long tmp = a[l], i = 0;
        while(tmp) tree[root][i] = tmp % 10, tmp /= 10, i++;
        //tree[root] = a[l];
    }
    else
    {
        long long mid = (l + r) / 2;
        build(root * 2, l, mid);
        build(root * 2 + 1, mid + 1, r);

        for(long long i = 0; i < K; ++i) tree[root][i] = tree[root * 2][i] + tree[root * 2 + 1][i];
        //tree[root] = tree[root * 2] + tree[root * 2 + 1];
    }
}

void push(long long root)
{
    long long p1[16], p2[16];//, ans[16];
    long long SZ1 = 0, SZ2 = 0, rot1 = lazy[root], rot2 = lazy[root];
    for(int i = 0; i < K; ++i)
    {
        p1[i] = tree[root * 2][i];
        p2[i] = tree[root * 2 +1][i];
        if(tree[root * 2][i]) SZ1++;
        if(tree[root * 2 + 1][i]) SZ2++;
    }
    //memset(ans, 0, sizeof(ans));
    //for(long long i = 0; i < K; ++i) if(tree[root][i]) SZ++;
    rot1 %= SZ1;
    for(long long k = 0; k < rot1; ++k)
    {
        long long tmp = p1[0];
        for(long long i = 1; i < K; ++i)
        {
            if(p1[i] == 0)
            {
                p1[i - 1] = tmp;
                break;
            }
            p1[i - 1] = p1[i];
        }
    }
    rot2 %= SZ2;
    for(long long k = 0; k < rot2; ++k)
    {
        long long tmp = p2[0];
        for(long long i = 1; i < K; ++i)
        {
            if(p2[i] == 0)
            {
                p2[i - 1] = tmp;
                break;
            }
            p2[i - 1] = p2[i];
        }
    }
    for(long long i = 0; i < K; ++i) tree[root][i] = p1[i] + p2[i];

    lazy[root * 2] += lazy[root];
    lazy[root * 2 + 1] += lazy[root];
    lazy[root] = 0;
}

void update2(long long root, long long l, long long r, long long ql, long long qr)
{
    //cout << l << " " << r << " " << ql << " " << qr << endl;
    push(root);
    if(l == ql && r == qr)
    {
        lazy[root]++;
        push(root);
    }
    else
    {
        push(root);
        long long mid = (l + r) / 2;
        if(qr <= mid) update2(root * 2, l, mid, ql, qr);
        else if(ql > mid) update2(root * 2 + 1, mid + 1, r, ql, qr);
        else update2(root * 2, l, mid, ql, mid), update2(root * 2 + 1, mid + 1, r, mid + 1, qr);
        push(root * 2);
        push(root * 2 + 1);
        for(long long i = 0; i < K; ++i) tree[root][i] = tree[root * 2][i] + tree[root * 2 + 1][i];
    }
}

long long query(long long root, long long l, long long r, long long ql, long long qr)
{
    push(root);
    if(l == ql && r == qr)
    {
        long long ans = 0;
        for(long long i = 0; i < K; ++i) ans += tree[root][i] * pw[i];
        return ans;
    }
    else
    {
        push(root);
        long long mid = (l + r) / 2;
        if(qr <= mid) return query(root * 2, l, mid, ql, qr);
        if(ql > mid) return query(root * 2 + 1, mid + 1, r, ql, qr);
        return query(root * 2, l, mid, ql, mid) + query(root * 2 + 1, mid + 1, r, mid + 1, qr);
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);

    long long n, q, tmp, t, l, r;
    cin >> n >> q;
    for(long long i = 1; i <= n; ++i)
    {
        cin >> a[i];
        tmp = a[i];
        while(tmp) sz[i]++, tmp /= 10;
    }
    build(1, 1, n);
    while(q--)
    {
        cin >> t;
        if(t == 1)
        {
            cin >> l >> r;
            update2(1, 1, n, l, r);
        }
        else cin >> l >> r, cout << query(1, 1, n, l, r) << endl;
        //cout << "TREE" << endl << "--------------------------" << endl;
        //for(long long i = 1; i <= 8; ++i, cout << endl)
        //    for(long long j = 0; j <= 4; ++j) cout << tree[i][j] << " ";
    }
    return 0;
}
/*
4 10
27 35 115 29
2 1 4
1 1 2
1 2 3
1 3 4
2 2 3
1 2 3
1 2 3
1 2 3
1 2 3
2 1 4

4 10
27 35 51 29
2 1 4
1 1 2
1 2 3
1 3 4
2 2 3
1 2 3
1 2 3
1 2 3
1 2 3
2 1 4
*/
