#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
vector<int> a;

void read() {
    cin >> n >> q;

    a.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
}

vector<long long> tree;

void build(int node, int low, int high) {
    if (low == high) {
        tree[node] = a[low];
        return;
    }

    int mid = (low + high) >> 1;
    build(node << 1, low, mid);
    build(node << 1 | 1, mid + 1, high);

    tree[node] = tree[node << 1] + tree[node << 1 | 1];
}

void update(int node, int low, int high, int pos, int value) {
    if (low == high) {
        tree[node] = value;
        return;
    }

    int mid = (low + high) >> 1;
    if (pos <= mid) {
        update(node << 1, low, mid, pos, value);
    } else {
        update(node << 1 | 1, mid + 1, high, pos, value);
    }

    tree[node] = tree[node << 1] + tree[node << 1 | 1];
}

long long query(int node, int low, int high, int l, int r) {
    if (high < l || low > r) {
        return 0;
    }

    if (low >= l && high <= r) {
        return tree[node];
    }

    int mid = (low + high) >> 1;
    return query(node << 1, low, mid, l, r) + query(node << 1 | 1, mid + 1, high, l, r);
}

void flip(int l, int r) {
    string str = to_string(a[l]);
    str = str.back() + str;
    str.pop_back();
    update(1, 1, n, l, stoi(str));
    a[l] = stoi(str);
}

void solve() {
    tree.resize(n << 2);
    build(1, 1, n);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) {
            flip(l, r);
        } else {
            cout << query(1, 1, n, l, r) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}

/*
3 5
15 35 112
2 1 2
1 2 2
2 1 3
1 1 1
2 2 3
*/
