#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
vector<int> a;

void read() {
    cin >> n >> q;

    a.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
}

vector<int> tree;

void add(int pos, int delta) {
    for (int i = pos; i <= n; i += i & -i) {
        tree[i] += delta;
    }
}

int query(int pos) {
    int answer = 0;
    for (int i = pos; i > 0; i -= i & -i) {
        answer += tree[i];
    }

    return answer;
}

void flip(int l, int r) {
    add(l, 1);
    if (r < n) {
        add(r + 1, -1);
    }
}

int get(int pos) {
    int numShifts = query(pos);
    string str = to_string(a[pos]);
    numShifts %= str.size();
    str = str.substr(str.size() - numShifts) + str.substr(0, str.size() - numShifts);
    return stoi(str);
}

void solve() {
    tree.resize(n + 1, 0);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) {
            flip(l, r);
        } else {
            cout << get(l) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}

/*
1 7
197
2 1 1
1 1 1
2 1 1
1 1 1
2 1 1
1 1 1
2 1 1
*/
