#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

struct Node {
    long long sum;
    bool flip;
    bool reversed;

    Node() {
        this->sum = 0;
        this->flip = this->reversed = false;
    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
vector<int> a;

void read() {
    cin >> n >> q;

    a.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
}

vector<vector<long long>> sum;

int reverseNumber(int number) {
    return ((number % 10) * 10 + number / 10);
}

int query(int id, int l, int r) {
    int answer = sum[id][r];
    if (l > 1) {
        answer -= sum[id][l - 1];
    }

    return answer;
}

vector<Node> tree;

void build(int node, int low, int high) {
    if (low == high) {
        tree[node].sum = a[low];
        return;
    }

    int mid = (low + high) >> 1;
    build(node << 1, low, mid);
    build(node << 1 | 1, mid + 1, high);

    tree[node].sum = tree[node << 1].sum + tree[node << 1 | 1].sum;
}

void push(int node, int low, int high) {
    if (tree[node].flip) {
        tree[node].sum = query(tree[node].reversed ^ 1, low, high);
        tree[node].reversed ^= 1;

        if (low != high) {
            tree[node << 1].flip ^= 1;
            tree[node << 1 | 1].flip ^= 1;
        }

        tree[node].flip = false;
    }
}

void flip(int node, int low, int high, int l, int r) {
    push(node, low, high);

    if (high < l || low > r) {
        return;
    }

    if (low >= l && high <= r) {
        tree[node].flip ^= 1;
        push(node, low, high);
        return;
    }

    int mid = (low + high) >> 1;
    flip(node << 1, low, mid, l, r);
    flip(node << 1 | 1, mid + 1, high, l, r);

    tree[node].sum = tree[node << 1].sum + tree[node << 1 | 1].sum;
}

long long query(int node, int low, int high, int l, int r) {
    push(node, low, high);

    if (high < l || low > r) {
        return 0;
    }

    if (low >= l && high <= r) {
        return tree[node].sum;
    }

    int mid = (low + high) >> 1;
    return query(node << 1, low, mid, l, r) + query(node << 1 | 1, mid + 1, high, l, r);
}

void solve() {
    sum.resize(2, vector<long long>(n + 1));

    sum[0][1] = a[1];
    sum[1][1] = reverseNumber(a[1]);

    for (int i = 2; i <= n; i++) {
        sum[0][i] = sum[0][i - 1] + a[i];
        sum[1][i] = sum[1][i - 1] + reverseNumber(a[i]);
    }

    tree.resize(n << 2);
    build(1, 1, n);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) {
            flip(1, 1, n, l, r);
        } else {
            cout << query(1, 1, n, l, r) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}

/*
3 5
15 35 12
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3
*/
