#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int a[MAXN + 5];
int lazy[4 * MAXN + 5];
vector<int> tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    tree[v].resize(2);
    if (l == r)
    {
        int x = a[l];
        for (int i = 0; i < 2; ++ i)
        {
            tree[v][i] = x % 10;
            x /= 10;
        }
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    for (int i = 0; i < 2; ++ i)
    {
        tree[v][i] = tree[2 * v][i] + tree[2 * v + 1][i];
    }
}

void push(int v, int l, int r)
{
    lazy[v] %= 2;
    if (lazy[v] == 1) swap(tree[v][0], tree[v][1]);
    if (l != r)
    {
        lazy[2 * v] += lazy[v];
        lazy[2 * v + 1] += lazy[v];
    }
    lazy[v] = 0;
}

void update(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R < l or r < L) return;
    if (L <= l and r <= R)
    {
        lazy[v]++;
        push(v, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(2 * v, l, mid, L, R);
    update(2 * v + 1, mid + 1, r, L, R);
    for (int i = 0; i < 2; ++ i)
    {
        tree[v][i] = tree[2 * v][i] + tree[2 * v + 1][i];
    }
}

int query(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R < l or r < L) return 0;
    if (L <= l and r <= R) return (10 * tree[v][1] + tree[v][0]);

    int mid = (l + r) / 2;
    return (query(2 * v, l, mid, L, R) + query(2 * v + 1, mid + 1, r, L, R));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    build(1, 1, n);

    for (int i = 1; i <= q; ++ i)
    {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) update(1, 1, n, l, r);
        else cout << query(1, 1, n, l, r) << endl;
    }

    return 0;
}
