#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int a[MAXN + 5];
int lazy[2 * MAXN + 5];
vector<int> tree[2 * MAXN + 5][7];

void build(int v, int l, int r)
{
    for (int i = 1; i <= 6; ++ i)
    {
        tree[v][i].resize(i + 1, 0);
    }

    if (l == r)
    {
        int x = a[l], cnt = 0;
        while (x)
        {
            x /= 10;
            cnt++;
        }

        x = a[l];
        for (int i = 1; i <= cnt; ++ i)
        {
            tree[v][cnt][i] = x % 10;
            x /= 10;
        }

        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    for (int i = 1; i <= 6; ++ i)
    {
        for (int j = 1; j <= i; ++ j)
        {
            tree[v][i][j] = tree[2 * v][i][j] + tree[2 * v + 1][i][j];
        }
    }
}

void push(int v, int l, int r)
{
    for (int i = 1; i <= 6; ++ i)
    {
        int l = lazy[v] % i;
        vector<int> t;
        t.resize(i + 1, 0);
        for (int j = 1; j <= i; ++ j)
        {
            int idx = j + l;
            if (idx > i) idx -= i;
            t[j] = tree[v][i][idx];
        }
        tree[v][i] = t;
    }
    if (l != r)
    {
        lazy[2 * v] += lazy[v];
        lazy[2 * v + 1] += lazy[v];
    }
    lazy[v] = 0;
}

void update(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R < l or r < L) return;
    if (L <= l and r <= R)
    {
        lazy[v]++;
        push(v, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(2 * v, l, mid, L, R);
    update(2 * v + 1, mid + 1, r, L, R);
    for (int i = 1; i <= 6; ++ i)
    {
        for (int j = 1; j <= i; ++ j)
        {
            tree[v][i][j] = tree[2 * v][i][j] + tree[2 * v + 1][i][j];
        }
    }
}

long long sum(int v)
{
    long long ret = 0;
    for (int i = 1; i <= 6; ++ i)
    {
        int pw = 1;
        for (int j = 1; j <= i; ++ j)
        {
            ret += 1ll * tree[v][i][j] * pw;
            pw *= 10;
        }
    }
    return ret;
}

long long query(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R < l or r < L) return 0;
    if (L <= l and r <= R) return sum(v);

    int mid = (l + r) / 2;
    return (query(2 * v, l, mid, L, R) + query(2 * v + 1, mid + 1, r, L, R));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    build(1, 1, n);

    for (int i = 1; i <= q; ++ i)
    {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) update(1, 1, n, l, r);
        else cout << query(1, 1, n, l, r) << endl;
    }

    return 0;
}
