#include <iostream>
using namespace std;
#define endl '\n'
const int MAXN=1e6+10;
long long a[MAXN], tree[8][4*MAXN][6], lazy[MAXN], cur[8];
void print_node(int node, int l, int r) {
    cout << node << ' ' << l << ' ' << r << endl;
    for (int i=1;i<=6;i++) {
        cout << i << ": ";
        for (int j=0;j<i;j++) cout << tree[i][node][j] << ' ';
        cout << endl;
    }
}
void merge_tree(int node) {
    for (int i=1;i<=6;i++) {
        for (int j=0;j<i;j++) tree[i][node][j]=tree[i][node*2][j]+tree[i][node*2+1][j];
    }
}
void build_tree(int node, int l, int r) {
    lazy[node]=0;
    if (l==r) {
        int k=a[l], i=0;
        while (k>0) {
            cur[i]=k%10;
            i++;
            k/=10;
        }
        for (int j=0;j<i;j++) tree[i][node][j]=cur[j];
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    merge_tree(node);
}
void push_lazy(int node, int l, int r) {
    if (lazy[node]==0) return;
    int rot;
    for (int i=1;i<=6;i++) {
        rot=lazy[node]%i;
        if (rot==0) continue;
        for (int j=0;j<i;j++) cur[j]=tree[i][node][j];
        for (int j=rot-1,k=i-1;j>=0;j--,k--) tree[i][node][k]=cur[j];
        for (int j=i-1,k=i-rot-1;k>=0;j--,k--) tree[i][node][k]=cur[j];
    }
    if (l<r) {
        lazy[node*2]+=lazy[node];
        lazy[node*2+1]+=lazy[node];
    }
    lazy[node]=0;
}
void update(int node, int l, int r, int ql, int qr) {
    if (l>qr || r<ql) return;
    push_lazy(node,l,r);
    if (l>=ql && r<=qr) {
        lazy[node]++;
        push_lazy(node,l,r);
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,ql,qr);
    update(node*2+1,mid+1,r,ql,qr);
    merge_tree(node);
}
long long find_sum(int node) {
    long long ans=0, st, ost;
    for (int i=0;i<6;i++) cur[i]=0;
    for (int i=1;i<=6;i++) {
        for (int j=0;j<i;j++) cur[j]+=tree[i][node][j];
    }
    st=1;
    ost=0;
    for (int i=0;i<6;i++) {
        ans+=((cur[i]+ost)%10)*st;
        ost=(cur[i]+ost)/10;
        st*=10;
        ///cout << i << ' ' << cur[i] << ' ' << ans << ' ' << ost << endl;
    }
    ans+=ost*st;
    return ans;
}
long long query(int node, int l, int r, int ql, int qr) {
    if (l>qr || r<ql) return 0;
    push_lazy(node,l,r);
    if (l>=ql && r<=qr) return find_sum(node);
    int mid=(l+r)/2;
    return query(node*2,l,mid,ql,qr)+query(node*2+1,mid+1,r,ql,qr);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i=0;i<n;i++) cin >> a[i];
    build_tree(1,0,n-1);
    int type, l, r;
    for (int i=0;i<q;i++) {
        cin >> type >> l >> r;
        l--; r--;
        if (type==1) update(1,0,n-1,l,r);
        else cout << query(1,0,n-1,l,r) << endl;
    }
    return 0;
}
/**
3 5
15 35 112
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3
**/
