#include <bits/stdc++.h>

#define MAX_N 1'000'006

struct Number {
	int64_t value;
	int64_t next_power_of_ten;
};

int64_t n, q;

Number tree[4 * MAX_N];

int calc_next_power_of_ten(int64_t x) {
	int64_t p = 1;
	while (x / p > 0) p *= 10;
	return p;
}

int64_t insert(int64_t root, int64_t root_l, int64_t root_r, int64_t idx, int64_t v) {
	if (idx < root_l || root_r < idx || root_r < root_l) return tree[root].value;
	if (root_l == root_r && root_l == idx) {
		tree[root].next_power_of_ten = calc_next_power_of_ten(v);
		return tree[root].value = v;
	}
	return tree[root].value =
		insert(root * 2,     root_l,         root_r / 2, idx, v) +
		insert(root * 2 + 1, root_r / 2 + 1, root_r,     idx, v);
}

int64_t rot(int64_t root, int64_t root_l, int64_t root_r, int64_t l, int64_t r) {
	if (r < root_l || root_r < l || root_r < root_l) return tree[root].value;
	if (root_l == root_r) {
		tree[root].value += (tree[root].value % 10) * tree[root].next_power_of_ten;
		tree[root].value /= 10;
		return tree[root].value;
	}
	return tree[root].value =
		rot(root * 2,     root_l,         root_r / 2, l, r) +
		rot(root * 2 + 1, root_r / 2 + 1, root_r,     l, r);
}

int64_t sum(int64_t root, int64_t root_l, int64_t root_r, int64_t l, int64_t r) {
	if (r < root_l || root_r < l || root_r < root_l) return 0;
	if (l <= root_l && root_r <= r) return tree[root].value;
	return
		sum(root * 2,     root_l,         root_r / 2, l, r) +
		sum(root * 2 + 1, root_r / 2 + 1, root_r,     l, r);
}

int main() {
	scanf("%lld%lld", &n, &q);
	for (int64_t i = 0; i < n; i += 1) {
		int64_t v;
		scanf("%lld", &v);
		insert(1, 0, n-1, i, v);
	}
	
	for (int i = 0; i < q; i += 1) {
		int64_t type, l, r;
		scanf("%lld%lld%lld", &type, &l, &r);
		l -= 1;
		r -= 1;
		if (type == 1) rot(1, 0, n-1, l, r);
		else           printf("%lld\n", sum(1, 0, n-1, l, r));
	}
}