#include <bits/stdc++.h>

#define MAX_N 1'000'006

struct Number {
	int64_t ones;
	int64_t tens;
	bool lazy_flip;
};

int64_t n, q;

Number tree[8 * MAX_N];

void insert(int64_t root, int64_t root_l, int64_t root_r, int64_t idx, int64_t v) {
	if (idx < root_l || root_r < idx) return;
	if (root_l == root_r && root_l == idx) {
		tree[root].ones = v % 10;
		tree[root].tens = v / 10;
		return;
	}

	uint64_t root_m = (root_l + root_r) / 2;
	insert(root * 2,     root_l,     root_m, idx, v);
	insert(root * 2 + 1, root_m + 1, root_r, idx, v);
	
	tree[root].ones = tree[root*2].ones + tree[root*2+1].ones;
	tree[root].tens = tree[root*2].tens + tree[root*2+1].tens;
}

void rot(int64_t root, int64_t root_l, int64_t root_r, int64_t l, int64_t r) {
	if (tree[root].lazy_flip) {
		tree[root].lazy_flip = false;
		std::swap(tree[root].ones, tree[root].tens);
		tree[root*2]  .lazy_flip = !tree[root*2]  .lazy_flip;
		tree[root*2+1].lazy_flip = !tree[root*2+1].lazy_flip;
	}

	if (r < root_l || root_r < l) return;
	if (l <= root_l && root_r <= r) {
		tree[root].lazy_flip = !tree[root].lazy_flip;
		if (tree[root].lazy_flip) {
			tree[root].lazy_flip = false;
			std::swap(tree[root].ones, tree[root].tens);
			tree[root*2]  .lazy_flip = !tree[root*2]  .lazy_flip;
			tree[root*2+1].lazy_flip = !tree[root*2+1].lazy_flip;
		}
		return;
	}
	
	uint64_t root_m = (root_l + root_r) / 2;
	rot(root * 2,     root_l,     root_m, l, r);
	rot(root * 2 + 1, root_m + 1, root_r, l, r);

	tree[root].ones = tree[root*2].ones + tree[root*2+1].ones;
	tree[root].tens = tree[root*2].tens + tree[root*2+1].tens;
}

int64_t sum(int64_t root, int64_t root_l, int64_t root_r, int64_t l, int64_t r) {	
	if (tree[root].lazy_flip) {
		tree[root].lazy_flip = false;
		std::swap(tree[root].ones, tree[root].tens);
		tree[root*2]  .lazy_flip = !tree[root*2]  .lazy_flip;
		tree[root*2+1].lazy_flip = !tree[root*2+1].lazy_flip;
	}
	
	if (r < root_l || root_r < l) return 0;	

	if (l <= root_l && root_r <= r)	return 10 * tree[root].tens + tree[root].ones;
	
	uint64_t root_m = (root_l + root_r) / 2;
	return
		sum(root * 2,     root_l,     root_m, l, r) +
		sum(root * 2 + 1, root_m + 1, root_r, l, r);
}

int main() {
	scanf("%lld%lld", &n, &q);
	for (int64_t i = 0; i < n; i += 1) {
		int64_t v;
		scanf("%lld", &v);
		insert(1, 0, n-1, i, v);
	}
	
	for (int i = 0; i < q; i += 1) {
		int64_t type, l, r;
		scanf("%lld%lld%lld", &type, &l, &r);
		l -= 1;
		r -= 1;
		if (type == 1) rot(1, 0, n-1, l, r);
		else           printf("%lld\n", sum(1, 0, n-1, l, r));
	}
}