#include <bits/stdc++.h>

#define MAX_N 1'000'006

struct Node {
	int64_t digits[6][6];
	int64_t lazy;
};

int64_t n, q;

Node *tree;

Node add(Node a, Node b) {
	Node ret = {};
	// Manual unrolling
	/*
	for (int64_t i = 0; i < 6; i += 1) {
		for (int64_t j = 0; j <= i; j += 1) {
			ret.digits[i][j] = a.digits[i][j] + b.digits[i][j];
		}
	}
	*/
	ret.digits[0][0] = a.digits[0][0] + b.digits[0][0];
	ret.digits[1][0] = a.digits[1][0] + b.digits[1][0];
	ret.digits[1][1] = a.digits[1][1] + b.digits[1][1];
	ret.digits[2][0] = a.digits[2][0] + b.digits[2][0];
	ret.digits[2][1] = a.digits[2][1] + b.digits[2][1];
	ret.digits[2][2] = a.digits[2][2] + b.digits[2][2];
	ret.digits[3][0] = a.digits[3][0] + b.digits[3][0];
	ret.digits[3][1] = a.digits[3][1] + b.digits[3][1];
	ret.digits[3][2] = a.digits[3][2] + b.digits[3][2];
	ret.digits[3][3] = a.digits[3][3] + b.digits[3][3];
	ret.digits[4][0] = a.digits[4][0] + b.digits[4][0];
	ret.digits[4][1] = a.digits[4][1] + b.digits[4][1];
	ret.digits[4][2] = a.digits[4][2] + b.digits[4][2];
	ret.digits[4][3] = a.digits[4][3] + b.digits[4][3];
	ret.digits[4][4] = a.digits[4][4] + b.digits[4][4];
	ret.digits[5][0] = a.digits[5][0] + b.digits[5][0];
	ret.digits[5][1] = a.digits[5][1] + b.digits[5][1];
	ret.digits[5][2] = a.digits[5][2] + b.digits[5][2];
	ret.digits[5][3] = a.digits[5][3] + b.digits[5][3];
	ret.digits[5][4] = a.digits[5][4] + b.digits[5][4];
	ret.digits[5][5] = a.digits[5][5] + b.digits[5][5];

	return ret;
}

Node rot_by_lazy(Node a) {
	Node ret = {};
	/*
	for (int64_t i = 0; i < 6; i += 1) {
		for (int64_t j = 0; j <= i; j += 1) {
			ret.digits[i][j] = a.digits[i][(j+a.lazy) % (i+1)];
		}
	}
	*/
	ret.digits[0][0] = a.digits[0][(0+a.lazy) % (1+1)];
	ret.digits[1][0] = a.digits[1][(0+a.lazy) % (2+1)];
	ret.digits[1][1] = a.digits[1][(1+a.lazy) % (2+1)];
	ret.digits[2][0] = a.digits[2][(0+a.lazy) % (3+1)];
	ret.digits[2][1] = a.digits[2][(1+a.lazy) % (3+1)];
	ret.digits[2][2] = a.digits[2][(2+a.lazy) % (3+1)];
	ret.digits[3][0] = a.digits[3][(0+a.lazy) % (4+1)];
	ret.digits[3][1] = a.digits[3][(1+a.lazy) % (4+1)];
	ret.digits[3][2] = a.digits[3][(2+a.lazy) % (4+1)];
	ret.digits[3][3] = a.digits[3][(3+a.lazy) % (4+1)];
	ret.digits[4][0] = a.digits[4][(0+a.lazy) % (5+1)];
	ret.digits[4][1] = a.digits[4][(1+a.lazy) % (5+1)];
	ret.digits[4][2] = a.digits[4][(2+a.lazy) % (5+1)];
	ret.digits[4][3] = a.digits[4][(3+a.lazy) % (5+1)];
	ret.digits[4][4] = a.digits[4][(4+a.lazy) % (5+1)];
	ret.digits[5][0] = a.digits[5][(0+a.lazy) % (6+1)];
	ret.digits[5][1] = a.digits[5][(1+a.lazy) % (6+1)];
	ret.digits[5][2] = a.digits[5][(2+a.lazy) % (6+1)];
	ret.digits[5][3] = a.digits[5][(3+a.lazy) % (6+1)];
	ret.digits[5][4] = a.digits[5][(4+a.lazy) % (6+1)];
	ret.digits[5][5] = a.digits[5][(5+a.lazy) % (6+1)];

	return ret;
}

int64_t calc_sum(Node a) {
	int64_t ret = 0;
	for (int64_t i = 0; i < 6; i += 1) {
		int64_t curr_sum = 0;
		for (int64_t j = i; j >= 0; j -= 1) {
			curr_sum *= 10;
			curr_sum += a.digits[i][j];
		}
		ret += curr_sum;
	}
	return ret;
}

void insert(int64_t root, int64_t root_l, int64_t root_r, int64_t idx, int64_t v) {
	if (idx < root_l || root_r < idx) return;
	if (root_l == root_r && root_l == idx) {
		Node cur = {};
		
		int64_t digits = 0;
		int64_t tmp = v;
		
		while (tmp != 0) {
			digits += 1;
			tmp /= 10;
		}
		
		for (int64_t i = 0; i < digits; i += 1) {
			cur.digits[digits-1][i] = v % 10;
			v /= 10;
		}
		
		tree[root] = cur;
		return;
	}

	uint64_t root_m = (root_l + root_r) / 2;
	insert(root * 2,     root_l,     root_m, idx, v);
	insert(root * 2 + 1, root_m + 1, root_r, idx, v);
	
	tree[root] = add(tree[root*2], tree[root*2+1]);
}

void rot(int64_t root, int64_t root_l, int64_t root_r, int64_t l, int64_t r) {
	tree[root*2]  .lazy += tree[root].lazy;
	tree[root*2+1].lazy += tree[root].lazy;
	tree[root] = rot_by_lazy(tree[root]);

	if (r < root_l || root_r < l) return;
	if (l <= root_l && root_r <= r) {
		tree[root].lazy = 1;
		if (root_l != root_r) tree[root*2]  .lazy += tree[root].lazy;
		if (root_l != root_r) tree[root*2+1].lazy += tree[root].lazy;
		tree[root] = rot_by_lazy(tree[root]);
		return;
	}
	
	uint64_t root_m = (root_l + root_r) / 2;
	rot(root * 2,     root_l,     root_m, l, r);
	rot(root * 2 + 1, root_m + 1, root_r, l, r);

	tree[root] = add(tree[root*2], tree[root*2+1]);
}

int64_t sum(int64_t root, int64_t root_l, int64_t root_r, int64_t l, int64_t r) {	
	if (r < root_l || root_r < l) return 0;	

	tree[root*2]  .lazy += tree[root].lazy;
	tree[root*2+1].lazy += tree[root].lazy;
	tree[root] = rot_by_lazy(tree[root]);

	if (l <= root_l && root_r <= r)	return calc_sum(tree[root]);
	
	uint64_t root_m = (root_l + root_r) / 2;
	return
		sum(root * 2,     root_l,     root_m, l, r) +
		sum(root * 2 + 1, root_m + 1, root_r, l, r);
}

int main() {
	tree = (Node*)malloc(sizeof(*tree) * 8 * MAX_N);
	
	scanf("%lld%lld", &n, &q);
	for (int64_t i = 0; i < n; i += 1) {
		int64_t v;
		scanf("%lld", &v);
		insert(1, 0, n-1, i, v);
	}
	
	for (int64_t i = 0; i < q; i += 1) {
		int64_t type, l, r;
		scanf("%lld%lld%lld", &type, &l, &r);
		l -= 1;
		r -= 1;
		if (type == 1) rot(1, 0, n-1, l, r);
		else           printf("%lld\n", sum(1, 0, n-1, l, r));
	}
}