#include <iostream>
#include <string>
#include <algorithm>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 1000005
//idx, length, degree
int tree[4 * MAXN][6][6];
int lazy[4 * MAXN];
int arr[MAXN], power[8];
int br, q;
void build(int idx, int from, int to)
{
    if(from > to) return;
    if(from == to){
        string s = to_string(arr[from]);
        reverse(s.begin(), s.end());
        for(int i = 0; i < s.size(); ++i){
            tree[idx][(int) s.size() - 1][i] = (s[i] - '0');
        }
        return;
    }
    int mid = (from + to) / 2;
    build(2 * idx, from, mid); build(2 * idx + 1, mid + 1, to);
    for(int i = 0; i <= 5; ++i){
        for(int z = 0; z <= i; ++z){
            tree[idx][i][z] = tree[2 * idx][i][z] + tree[2 * idx + 1][i][z];
        }
    }
}
void execute(int idx)
{
    for(int i = 0; i <= 5; ++i){
        int cpi = tree[idx][i][0];
        for(int z = 0; z < i; ++z){
            tree[idx][i][z] = tree[idx][i][z + 1];
        }
        tree[idx][i][i] = cpi;
    }
}
void fix(int idx, int from, int to)
{
    if(lazy[idx] == 0) return;
    if(from != to){
        lazy[2 * idx] += lazy[idx]; lazy[2 * idx + 1] += lazy[idx];
    }
    int cpi = lazy[idx]; lazy[idx] = 0;
    for(int i = 0; i <= 5; ++i){
        int arrc[5];
        for(int z = 0; z <= i; ++z) arrc[z] = tree[idx][i][z];
        for(int z = 0; z <= i; ++z){
            tree[idx][i][z] = arrc[(z + cpi) % (i + 1)];
        }
    }
}
void rotation(int idx, int from, int to, int l, int r)
{
    if(from > to) return;
    if(l > to || from > r) return;
    if(from >= l && to <= r){
        lazy[idx]++;
        fix(idx, from, to);
        return;
    }
    fix(idx, from, to);
    int mid = (from + to) / 2;
    rotation(2 * idx, from, mid, l, r); rotation(2 * idx + 1, mid + 1, to, l, r);
    fix(2 * idx, from, mid); fix(2 * idx + 1, mid + 1, to);
    for(int i = 0; i <= 5; ++i){
        for(int z = 0; z <= i; ++z){
            tree[idx][i][z] = tree[2 * idx][i][z] + tree[2 * idx + 1][i][z];
        }
    }
}
int query(int idx, int from, int to, int l, int r)
{
    if(from > to) return 0;
    if(l > to || from > r) return 0;
    if(from >= l && to <= r){
        fix(idx, from, to);
        int sum = 0;
        for(int i = 0; i <= 5; ++i){
            for(int z = 0; z <= i; ++z){
                sum += tree[idx][i][z] * power[z];
            }
        }
        return sum;
    }
    fix(idx, from, to);
    int mid = (from + to) / 2;
    fix(2 * idx, from, mid); fix(2 * idx + 1, mid + 1, to);
    int sum = query(2 * idx, from, mid, l, r) + query(2 * idx + 1, mid + 1, to, l, r);
    return sum;
}
signed main()
{
    power[0] = 1;
    for(int i = 1; i < 8; ++i){
        power[i] = power[i - 1] * 10;
    }
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br >> q;
    for(int i = 0; i < br; ++i){
        cin >> arr[i];
    }
    build(1, 0, br - 1);
    for(int i = 0; i < q; ++i){
        int t, from, to; cin >> t >> from >> to; --from; --to;
        if(t == 1){
            rotation(1, 0, br - 1, from, to);
        }
        else{
            cout << query(1, 0, br - 1, from, to) << endl;
        }
    }
    return 0;
}
