#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#define int long long
const int maxn = 2e5+10, mod = 1e9+7;

int n, q;
int a[maxn], powers[2*maxn];
int ans;
std::unordered_set < int > s;
std::vector < int > gcds;

void update(int x, bool add)
{
    gcds.clear();
    for (auto i : s)
        gcds.push_back(std::__gcd(i, x));
    std::sort(gcds.begin(), gcds.end());


    for (int i = 0 ; i < gcds.size() ; ++i)
    {
        if (add) ans = (ans + gcds[i] * powers[gcds.size() - i - 1]) % mod;
        else
        {
            ans -= (gcds[i] * powers[gcds.size() - i - 1]) % mod;
            if (ans < 0) ans += mod;
        }
    }
    if (add) ans += x;
    else ans -= x;
    if (ans >= mod) ans -= mod;
    if (ans < 0) ans += mod;

}

void solve()
{
    powers[0] = 1;
    for (int i = 1 ; i <= n+q ; ++i) powers[i] = (powers[i-1] * 2) % mod;
    for (int i = 1 ; i <= n ; ++i)
    {
        update(a[i], 1);
        s.insert(a[i]);
    }

    std::cout << ans << '\n';
    int qtype, x;
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> qtype >> x;
        if (qtype == 1)
        {
            update(x, 1);
            s.insert(x);
        } else 
        {
            s.erase(s.find(x));
            update(x, 0);
        }
        std::cout << ans << '\n';
    }
}

void read()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i) std::cin >> a[i];
}

void fast_io()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fast_io();
    read();
    solve();

    return 0;
}

/*
6
1 2
2 6
2 3
3 4
3 5
1 2 1 1 3 1
7
3 1 5
3 4 5
3 6 5
2 3 1
3 1 5
2 3 2
3 1 5
*/