#include <iostream>
typedef long long llong;
const int maxn = 1e6+10;

int n, q;

llong tree[4*maxn][60];
int lazy[4*maxn];
int digits[maxn];
int a[maxn];

int rot(int x, int log)
{
    return x/10 + (x%10)*log;
}

inline void combine(int node)
{
    for (int i = 0 ; i < 60 ; ++i)
        tree[node][i] = tree[2*node][i] + tree[2*node+1][i];
}

void init(int l, int r, int node)
{
    if (l == r)
    {
        int currnum = a[l];
        for (int i = 0 ; i < 60 ; ++i)
        {
            tree[node][i] = currnum;
            currnum = rot(currnum, digits[l]);
        }
        return;
    }

    int mid = (l+r)/2;
    init(l, mid, 2*node);
    init(mid+1, r, 2*node+1);
    combine(node);
}

llong buff[60];
void push(int node, int l, int r)
{
    if (lazy[node] == 0) return;
    for (int i = 0 ; i < 60 ; ++i) buff[i] = tree[node][(i + lazy[node]) % 60];
    for (int i = 0 ; i < 60 ; ++i) tree[node][i] = buff[i];
    if (l < r)
    {
        lazy[2*node] += lazy[node];
        lazy[2*node+1] += lazy[node];
    }
    lazy[node] = 0;
}

void update(int l, int r, int node, int queryL, int queryR)
{
    push(node, l, r);
    if (queryR < l || r < queryL) return;
    if (queryL <= l && r <= queryR)
    {
        ++lazy[node];
        push(node, l, r);
        return;
    }
    int mid = (l+r)/2;
    update(l, mid, 2*node, queryL, queryR);
    update(mid+1, r, 2*node+1, queryL, queryR);
    combine(node);
}

llong query(int l, int r, int node, int queryL, int queryR)
{
    push(node, l, r);
    if (queryL <= l && r <= queryR) return tree[node][0];
    
    int mid = (l+r)/2;
    llong ans = 0;
    if (queryL <= mid) ans += query(l, mid, 2*node, queryL, queryR);
    if (mid+1 <= queryR) ans += query(mid+1, r, 2*node+1, queryL, queryR);
    
    return ans;
}

void solve()
{
    int curr;
    for (int i = 1 ; i <= n ; ++i)
    {
        curr = a[i]; digits[i] = 1;
        while (curr >= 10) digits[i] *= 10, curr /= 10;
    }

    init(1, n, 1);
    int qtype, l, r;

    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> qtype >> l >> r;
        if (qtype == 1) update(1, n, 1, l, r);
        else std::cout << query(1, n, 1, l, r) << '\n';
    }
}

void read()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i) std::cin >> a[i];
}

void fast_io()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fast_io();
    read();
    solve();

    return 0;
}

/*
6
1 2
2 6
2 3
3 4
3 5
1 2 1 1 3 1
7
3 1 5
3 4 5
3 6 5
2 3 1
3 1 5
2 3 2
3 1 5
*/